Package: anota
Version: 1.60.0
Date: 2011-03-03
Title: ANalysis Of Translational Activity (ANOTA).
Author: Ola Larsson <ola.larsson@ki.se>, Nahum Sonenberg
        <nahum.sonenberg@mcgill.ca>, Robert Nadon
        <robert.nadon@mcgill.ca>
Maintainer: Ola Larsson <ola.larsson@ki.se>
Description: Genome wide studies of translational control is emerging
        as a tool to study verious biological conditions. The output
        from such analysis is both the mRNA level (e.g. cytosolic mRNA
        level) and the levl of mRNA actively involved in translation
        (the actively translating mRNA level) for each mRNA. The
        standard analysis of such data strives towards identifying
        differential translational between two or more sample classes -
        i.e. differences in actively translated mRNA levels that are
        independent of underlying differences in cytosolic mRNA levels.
        This package allows for such analysis using partial variances
        and the random variance model. As 10s of thousands of mRNAs are
        analyzed in parallell the library performs a number of tests to
        assure that the data set is suitable for such analysis.
Imports: multtest, qvalue
Depends: qvalue
LazyData: yes
LazyLoad: yes
License: GPL-3
biocViews: GeneExpression, DifferentialExpression, Microarray,
        Sequencing
git_url: https://git.bioconductor.org/packages/anota
git_branch: RELEASE_3_23
git_last_commit: dd09d4d
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 20:36:03 UTC; biocbuild

######################################################################
######################################################################
anotaSimDfbs <- function(nData=2000, phenoVec=phenoVec, mode=mode, useProgBar=useProgBar){
    nSamples <- length(phenoVec)
    ##Create matrix for simulated data
    dataPMatrix <- dataTMatrix <- matrix(ncol=nSamples, nrow=nData, data=NA)
    rownames(dataPMatrix) <- rownames(dataTMatrix) <- c(1:nData)
    ##The analysis is performed over a range of realistic correlations which are defined by the sd of the covariate.
    ##We have shown that this setting does not matter for the outcome because we use standardized dfbeta
    sdVec <- c(31:40/10)
    corMat <- matrix(ncol=length(sdVec), nrow=nData)
    ##A few structures to collect outputs
    pDfbCollect <- matrix(ncol=6, nrow=length(sdVec))
    row.names(pDfbCollect) <- sdVec
    corMeanMedCollect <- matrix(ncol=2, nrow=length(sdVec))
    rownames(corMeanMedCollect) <- sdVec
    colnames(corMeanMedCollect) <- c("Mean_correlation", "Median_correlation")
######################################################
    ##Start the analysis
    total <- length(sdVec)
    if(useProgBar==TRUE){
        pb <- txtProgressBar(min=0, max=total, style=3)
    }
    ##Over all the selected sds
    for(k in 1:length(sdVec)){
        if(useProgBar==TRUE){
            setTxtProgressBar(pb, k)
        }
        ##P and T is generated per gene
        for(j in 1:dim(dataPMatrix)[1]){
            ##sd=4 is arbitrary selected but gives a reasonable spread of the data and the setting does not influence the result.
            dataP <- rnorm(n=nSamples, mean=0, sd=4)
            dataT <- c(rep(NA, length(dataP)))
            for(i in 1:length(dataP)){
                dataT[i] <- rnorm(n=1, mean=dataP[i], sd=sdVec[k])
            }
            dataPMatrix[j,] <- dataP
            dataTMatrix[j,] <- dataT
        }
        ##Calculate and store the correlation per gene
        corVec <- c(rep(NA, nData))
        for(l in 1:length(corVec)){
            corVec[l] <- cor(dataPMatrix[l,], dataTMatrix[l,])
        }
        corMat[,k] <- corVec
        ##Store mean and median correlations
        corMeanMedCollect[k,1] <- mean(corVec)
        corMeanMedCollect[k,2] <- median(corVec)
        ##Run the dfb analysis and store the data
        dfbOut <- anotaDfbsSummaryOnly(dataT = dataTMatrix, dataP=dataPMatrix, phenoVec = phenoVec, mode=mode)
        ##Store the obtained dfb summary
        pDfbCollect[k,] <- as.vector(unlist(dfbOut$dfbSummary))
        colnames(pDfbCollect) <- colnames(dfbOut$dfbSummary)
    }
    cat("\n\n")
########################################
    ##Generate output for return
    outputList <- list(
                       "Correlation"=corMeanMedCollect,
                       "SimulatedDfbs" = pDfbCollect)
    return(outputList)
}


#############################################################################
#############################################################################
anotaDfbsSummaryFull <- function(lmDfb, mode, useDfbSim, filename, nDfbSimData, phenoVec, useProgBar=useProgBar){
    dsfSummary <- getSummaryDfb(lmDfb)

    ##Perform dfb simulation to get thresholds
    if(useDfbSim==TRUE){
        cat("\tPerforming dfbetas simulation\n")
        ##perform simulation
        nT <- length(phenoVec)
        ##mode decides how the simulation should be performed
        dfbSimOut <- anotaSimDfbs(nData=nDfbSimData, phenoVec=phenoVec, mode=mode, useProgBar=useProgBar)
        ##Get the output from anotaSimDfbs
        simDfbThreshold <- unlist(dfbSimOut$SimulatedDfbs)
        ##create a plot that compares obtined to simulated
        simDfbThresholdMean <- apply(simDfbThreshold, 2, mean)
        dsfSummary <- as.vector(unlist(dsfSummary))
        names(dsfSummary) <- c("dfb>1", "dfb>2", "dfb>3", "dfb>2/sqrt(N)", "dfb>3/sqrt(N)", "dfb>3.5*iqr")
        dfbDifference <- simDfbThresholdMean-dsfSummary
        dfbDifference <- round(dfbDifference, digits=4)
        tmpDfbMat <- cbind(simDfbThresholdMean, dsfSummary)
        tmpDfbMax <- apply(tmpDfbMat, 1, max)
        tmpVec <- c()
        for(r in 1:6){
            tmpVec <- c(tmpVec, dsfSummary[r], simDfbThresholdMean[r])
        }
        spaceVec <- c(0,0,rep(c(1,0),5))
        colVec <- rep(c(1,2),6)
        dfbsNames = c("dfb>1", "dfb>2", "dfb>3", "dfb>2/sqrt(N)", "dfb>3/sqrt(N)", "dfb>3.5*iqr")
        pdf(file=filename, width=6, height=4, pointsize=1/300)
        plot(x=c(0,17), y=c(0, c(max(tmpDfbMax))+0.01), ylab="Proportion of data points", xlab="Cut off method", main="Proportion of outliers in regression assessment using dfbetas", pch="", xaxt="n")
        barplot(tmpVec, space=spaceVec, col=colVec, add=TRUE)
        legend(x=1, y=max(tmpVec-0.002), legend=c("Obtained", "Simulated"), fill=c(1,2))
        text(y=c(tmpDfbMax+0.002), x=c(1, 4, 7, 10, 13, 16), labels=dfbDifference) 
        dev.off()
    }    
    ##Create a plotting output if no simulation was selected
    if(useDfbSim==FALSE){
        cat("\tNo dfbetas simulation is performed\n")
        dfbsNames <- c("dfb>1", "dfb>2", "dfb>3", "dfb>2/sqrt(N)", "dfb>3/sqrt(N)", "dfb>3.5*iqr")
        pdf(file=filename, width=6, height=4, pointsize=1/300)
        barplot(as.vector(unlist(dsfSummary)), names.arg=dfbsNames, cex.names=1, ylab="Proportion of data points", xlab="Cut off method", main="Proportion of outliers in regression assessment using dfbetas")
        dev.off()
    }
    return(dsfSummary)
}


#################################################################################
#################################################################################
anotaDfbsSummaryOnly <- function(dataT=NULL, dataP=NULL, phenoVec=NULL, mode=mode){
    ##Warnings
    if(is.null(dataT)){
        cat("ERROR: No data for total samples\n")
        stop()
    }
    if(is.null(dataP)){
        cat("ERROR: No data for polysomal samples\n")
        stop()
    }
    if(is.null(phenoVec)){
        cat("ERROR: No phenotypes specified\n")
        stop()
    }
    if(is.null(mode)){
        cat("ERROR: No mode specified\n")
        stop()
    }
    if(identical(rownames(dataT), rownames(dataP))==FALSE){
        cat("ERROR: Polysomal and Total rownames do not follow the same order\n")
        stop()
    }
################################################
    ##calculate n data points and factorise phenoVec
    nData <- dim(dataP)[1]
    phenoVec <- as.factor(phenoVec)
    ##structures to collect outputs
    lmDfb <- matrix(ncol=dim(dataT)[2], nrow=nData)
################################################
    ##Start analysis in a per gene loop
    for(i in 1:nData){
        ##lm model with interaction
        if(mode=="int"){
            tmpLm <- lm(dataP[i,]~dataT[i,]*phenoVec)
        }
        if(mode=="add"){
            tmpLm <- lm(dataP[i,]~dataT[i,]+phenoVec)
        }
        ##get dfbs for the slope i.e. in column 2
        tmpDfb <- dfbetas(tmpLm)
        lmDfb[i,] <- tmpDfb[,2]
    }
#################################################
    ##Evaluate outputs
    dfbSummary <- getSummaryDfb(lmDfb)
    
    ##Create a return object
    dataOut <- list(
                    "dfbSummary"=dfbSummary)
    return(dataOut) 
}

getSummaryDfb <- function(lmDfb){
        ##Evaluate outputs using different thresholds for dfbetas that have been suggested in the litterature.
    dfb1 <- lmDfb>1
    dfb2 <- lmDfb>2
    dfb3 <- lmDfb>3
    dfb2Sqrt <- lmDfb>(2/sqrt(dim(lmDfb)[2]))
    dfb3Sqrt <- lmDfb>(3/sqrt(dim(lmDfb)[2]))
    ##3.5X IQR. IQR is calculated per gene and each gene is tested separately but summarized across all.
    dfbIqr <- apply(lmDfb, 1, IQR)    
    dfbIqrTh <- 3.5*dfbIqr
    dfbIqrLog <- lmDfb>dfbIqrTh
    ##generate a summary output
    ##compare as a proportion of all tests    
    nTests <- ncol(lmDfb) * nrow(lmDfb)
    dfb1P <- sum(dfb1)/nTests
    dfb2P <- sum(dfb2)/nTests
    dfb3P <- sum(dfb3)/nTests
    dfb2SqrtP <- sum(dfb2Sqrt)/nTests
    dfb3SqrtP <- sum(dfb3Sqrt)/nTests
    dfbIqrLogP <- sum(dfbIqrLog)/nTests
    dsfSummary <- list(
                       "Proportion data points with dfb>1"=dfb1P,
                       "Proportion data points with dfb>2"=dfb2P,
                       "Proportion data points with dfb>3"=dfb3P,
                       "Proportion data points with dfb>2/sqrt(N)"=dfb2SqrtP,
                       "Proportion data points with dfb>3/sqrt(N)"=dfb3SqrtP,
                       "Proportion data points with dfb>3.5*iqr"=dfbIqrLogP)
    return(dsfSummary)
}

##Perform quality control of the data set
##Perform ominubus analysis
anotaPerformQc<- function(dataT=NULL, dataP=NULL, phenoVec=NULL, generatePlot=FALSE, file="ANOTA_Total_vs_Polysomal_regressions.pdf", nReg=200, correctionMethod="BH", useDfb=TRUE, useDfbSim=TRUE, nDfbSimData=2000, useRVM=TRUE, onlyGroup=FALSE, useProgBar=TRUE){
    ##Get some basic descriptors of the data set
    nData <- dim(dataP)[1]
    phenoVecOrg <- phenoVec
    phenoVec <- as.factor(phenoVec)
    phenoLev <- levels(phenoVec)
    nPheno <- length(phenoLev)
    
    ##Warnings
    ##do the data structures fit with each other?
    anotaPerformQcWarnings1(dataT=dataT, dataP=dataP, phenoVec=phenoVec)
    ##is there sufficient replication?
    anotaPerformQcWarnings2(nPheno=nPheno, phenoLev=phenoLev, phenoVecOrg=phenoVecOrg, onlyGroup=onlyGroup)
##############################
    ##initiation of objects for qc (dfbetas, interactions, slopes) and analysis (omnibus group, intercepts and rvm)
    ##dfbetas structures
    lmFittedValsAdd <- lmResidAdd <- lmDfbAdd <- matrix(ncol=dim(dataT)[2], nrow=nData)
    colnames(lmFittedValsAdd) <- colnames(lmDfbAdd) <- colnames(lmResidAdd) <- colnames(dataP)
    rownames(lmFittedValsAdd) <- rownames(lmDfbAdd) <- rownames(lmResidAdd) <- rownames(dataP)
    
    ##interactions structures
    intP <- intPAdj<- intMS <- intRvmFval <- intDf <- intResidMS <- intResidMSRvm <- intRvmP <- intRvmPAdj <- intResidDf <- intResidDfRvm <- c(rep(NA, nData))
    names(intP) <- names(intPAdj) <- names(intMS) <- names(intRvmFval) <- names(intDf) <- names(intResidMS) <- names(intResidMSRvm) <- names(intRvmP) <- names(intRvmPAdj) <- names(intResidDf) <- names(intResidDfRvm) <- rownames(dataP)

    ##slope structures
    groupSlope <- groupSlopeP <- c(rep(NA, nData))
    names(groupSlope) <- names(groupSlopeP) <- rownames(dataP)
    
    ##group structures
    groupP <- groupPAdj <- groupMS <- groupRvmFval <-  groupDf <-groupResidMS <-  groupResidMSRvm  <- groupRvmP <-groupRvmPAdj<- groupResidDf <- groupResidDfRvm <- c(rep(NA, nData))
    names(groupP) <- names(groupPAdj) <- names(groupMS) <- names(groupRvmFval) <-  names(groupDf) <- names(groupResidMS) <-  names(groupResidMSRvm)  <- names(groupRvmP) <- names(groupRvmPAdj) <- names(groupResidDf) <- names(groupResidDfRvm) <- rownames(dataP)

    ##intercept structure
    groupIntercepts <- matrix(nrow=nData, ncol=nPheno)
    colnames(groupIntercepts) <- phenoLev
    rownames(groupIntercepts) <- rownames(dataP)

    ##rvm structures
    names <- rownames(dataP)
    abInt <- rvmSummary <- rvmSummaryGroup <- abGroup <- dsfSummaryAdd <- NULL
##############################
    ##initiate optional regression plot
    if(generatePlot==1){
        geneNames <- rownames(dataP)
        pdf(file, width=8, height=11, pointsize=1/600)
        par(mfrow=c(4,2))
    }
    cat("Running anotaPerformQc quality control\n")
##############################
    ##Start analysis in a per gene loop
    cat("\tCalculating omnibus interactions & effects and dfbetas\n")
    total <- nData
    if(useProgBar==TRUE){
        pb <- txtProgressBar(min=0, max=total, style=3)
    }
    for(i in 1:nData){
        if(useProgBar==TRUE){
            setTxtProgressBar(pb, i)
        }
        tmpList <- list("PolyRNA"=dataP[i,], "TotalRNA"=dataT[i,], "phenoType"=phenoVec)
        attach(tmpList)
        if(onlyGroup==FALSE){
            ##perform regression with interactions
            tmpLm <- lm(PolyRNA~TotalRNA*phenoType)
            ##Get omnibus interactions and stats
            tmpLmAov <- anova(tmpLm)
            intDf[i] <- tmpLmAov[3,1]
            intMS[i] <- tmpLmAov[3,3]
            intP[i] <- tmpLmAov[3,5]
            intResidDf[i] <- tmpLmAov[4,1]
            intResidMS[i] <- tmpLmAov[4,3]
        }
        ##get omnibus group effects without interaction
        tmpLm <- lm(PolyRNA~TotalRNA+phenoType)
        tmpLmAov <- anova(tmpLm)
        detach(tmpList)
        groupDf[i] <- tmpLmAov[2,1]
        groupMS[i] <- tmpLmAov[2,3]
        groupP[i] <- tmpLmAov[2,5]
        groupResidDf[i] <- tmpLmAov[3,1]
        groupResidMS[i] <- tmpLmAov[3,3]
        
        ##if slope is <0 or >1 test if there is significant difference else set to 1.
        groupSlope[i] <- tmpLm$coefficients[2]
        groupSlopeP[i] <- 1
        if(groupSlope[i]>1 | groupSlope[i]<0){
            groupSlopeP[i] <- anotaSlopeTest(tmpLm=tmpLm, curSlope=groupSlope[i])
        }
        
        ##get dfbetas for the slope i.e. in column 2 from the no interaction model
        if(useDfb==TRUE){
            tmpDfb <- dfbetas(tmpLm)
            lmDfbAdd[i,] <- tmpDfb[,2]
        }
        
        ##Collect residuals and fittedvalues
        lmResidAdd[i,] <- tmpLm$residuals
        lmFittedValsAdd[i,] <- tmpLm$fitted.values
        
        ##get class intercepts
        groupIntercepts[i,] <- anotaGetIntercepts(x=dataT[i,], y=dataP[i,], slope=groupSlope[i], phenoVecOrg=phenoVecOrg, phenoLev=phenoLev)
        
        ##Plot single gene regression
        if(generatePlot==1 & i<=nReg){
            anotaPlotSingleRegression(x=dataT[i,], y=dataP[i,], geneName=geneNames[i], intercepts=groupIntercepts[i,], slope=groupSlope[i], phenoVecOrg=phenoVecOrg, phenoLev=phenoLev)
        }
    }
    cat("\n\n")
    ##End plotting
    if(generatePlot==1){
        dev.off()
    }
    ##done per gene analysis
#############################################
    ##Dfb analysis with or without simulation
    if(useDfb==TRUE){
        cat("\tAssessing dfbetas for model without interaction\n")
        dsfSummaryAdd <- anotaDfbsSummaryFull(lmDfb=lmDfbAdd, mode="add", filename="ANOTA_simulated_vs_obt_dfbetas_without_interaction.pdf", useDfbSim=useDfbSim, nDfbSimData, phenoVec=phenoVecOrg, useProgBar=useProgBar)
    }
    
#############################################
    ##RVM analysis
    ##Interactions
    if(useRVM==TRUE & onlyGroup==FALSE){
        cat("\tUsing RVM for omnibus interaction statistics\n")
        jpeg("ANOTA_rvm_fit_for_interactions.jpg", width=800, height=400, quality=100)
        par(mfrow=c(1,2))
        anotaPlotIGFit(intResidMS, intResidDf[1], qqName="Fit for interactions")
        dev.off()
        ##adjust the intResidMSs based on the ab parameters
        tmpRVM <- anotaPerformRVM(MS=intMS, Df=intDf, residMS=intResidMS, residDf=intResidDf)
        intResidMSRvm <- tmpRVM$residMSRvm
        intResidDfRvm <- tmpRVM$residDfRvm
        intRvmFval <- tmpRVM$rvmFval
        intRvmP <- tmpRVM$rvmP
        abInt <- tmpRVM$ab
    }
    rvmSummary <- cbind(intMS, intDf, intResidMS, intResidDf, intResidMSRvm, intResidDfRvm,  intRvmFval, intP, intRvmP)
    
    ##Group effect
    if(useRVM==TRUE){
        cat("\tUsing RVM for omnibus group statistics\n")
        jpeg("ANOTA_rvm_fit_for_omnibus_group.jpg", width=800, height=400, quality=100)
        par(mfrow=c(1,2))
        anotaPlotIGFit(groupResidMS, groupResidDf[1], qqName="Fit for omnibus group")
        dev.off()
        ##adjust the groupResidMSs based on the ab parameters
        tmpRVM <- anotaPerformRVM(MS=groupMS, Df=groupDf, residMS=groupResidMS, residDf=groupResidDf)
        groupResidMSRvm <- tmpRVM$residMSRvm
        groupResidDfRvm <- tmpRVM$residDfRvm
        groupRvmFval <- tmpRVM$rvmFval
        groupRvmP <- tmpRVM$rvmP
        abGroup <- tmpRVM$ab
    }
    rvmSummaryGroup <- cbind(groupSlope,groupSlopeP, groupMS, groupDf, groupResidMS, groupResidDf, groupResidMSRvm, groupResidDfRvm,  groupRvmFval, groupP, groupRvmP)
    
########################################
    ##Multiple testing adjustments
    cat("\tAdjusting p-values for multiple testing\n\n")    
    ##one set for when multtest is used
    if(correctionMethod!="qvalue"){
        if(onlyGroup==FALSE){
            intPAdj <- anotaAdjustPvals(pVals=intP, correctionMethod=correctionMethod)
        }
        groupPAdj <- anotaAdjustPvals(pVals=groupP, correctionMethod=correctionMethod)
        if(useRVM==TRUE){
            if(onlyGroup==FALSE){
                intRvmPAdj <- anotaAdjustPvals(pVals=intRvmP, correctionMethod=correctionMethod)
            }
            groupRvmPAdj <- anotaAdjustPvals(pVals=groupRvmP, correctionMethod=correctionMethod)
        }
        rvmSummary <- cbind(rvmSummary, intPAdj, intRvmPAdj)
        rvmSummaryGroup <- cbind(rvmSummaryGroup, groupPAdj, groupRvmPAdj) 
    }
    
    ##another set for when it is storey qvalue
    if(correctionMethod=="qvalue"){
        if(onlyGroup==FALSE){
            intPAdj <- anotaAdjustPvalsQ(intP)
        }
        groupPAdj <- anotaAdjustPvalsQ(groupP)
        if(useRVM==TRUE){
            if(onlyGroup==FALSE){
                intRvmPAdj <- anotaAdjustPvalsQ(intRvmP)
            }
            groupRvmPAdj <- anotaAdjustPvalsQ(groupRvmP)
        }
        rvmSummary <- cbind(rvmSummary, intPAdj, intRvmPAdj)
        rvmSummaryGroup <- cbind(rvmSummaryGroup, groupPAdj, groupRvmPAdj) 
    }
    
###############################
    ##Plot for interaction p-values
    if(onlyGroup==FALSE){
        anotaPlotIntPvals(intP=intP, intPAdj=intPAdj, intRvmP=intRvmP, intRvmPAdj=intRvmPAdj, useRVM=useRVM, correctionMethod=correctionMethod)
    }
################################
    ##Create a return object
    dataOut <- list(
                    "omniIntStats"=rvmSummary,
                    "omniGroupStats"=rvmSummaryGroup,
                    "groupIntercepts"=groupIntercepts,
                    "correctionMethod"=correctionMethod,
                    "dsfSummary"=dsfSummaryAdd,
                    "dfbetas"=lmDfbAdd,
                    "residuals"=lmResidAdd,
                    "fittedValues"=lmFittedValsAdd,
                    "phenoClasses"=levels(phenoVec),
                    "sampleNames"=colnames(dataP),
                    "abParametersInt"=abInt,
                    "abParametersGroup"=abGroup)
    
    return(dataOut)
}


anotaPlotIntPvals <- function(intP, intPAdj, intRvmP, intRvmPAdj, useRVM, correctionMethod){
    cAx <- 2
    cLab <- 2
    cMain <- 2
    pdf("ANOTA_interaction_p_distribution.pdf", height=10, width=10, pointsize=1/300)
    par(mar=c(5,6,4,2))
    par(mfrow=c(2,2))
    
    plot(density(intP), main="Omnibus interaction p-values", xlab="p-value", cex.axis=cAx, cex.lab=cLab, cex.main=cMain)
    
    tmpMain <- paste("Omnibus interaction adjusted p-values", "(", correctionMethod, ")")
    plot(density(intPAdj), main=tmpMain, xlab="Adjusted p-value", cex.axis=cAx, cex.lab=cLab, cex.main=cMain)
    hist(intP,  main="Omnibus interaction p-values",breaks=c(0:40)/40, xlab="p-value",
         cex.axis=cAx, cex.lab=cLab, cex.main=cMain)
    
    hist(intPAdj,  main=tmpMain, breaks=c(0:40)/40, xlab="Adjusted p-value",
         cex.axis=cAx, cex.lab=cLab, cex.main=cMain)
    
    if(useRVM==TRUE){
        plot(density(intRvmP), main="Omnibus interaction RVM p-values",
             xlab="RVM p-value", cex.axis=cAx, cex.lab=cLab, cex.main=cMain)
        
        tmpMain <- paste("Omnibus interaction adjusted RVM p-values", "(", correctionMethod, ")")
        plot(density(intRvmPAdj), main=tmpMain, xlab="Adjusted RVM p-value",
             cex.axis=cAx, cex.lab=cLab, cex.main=cMain)
        
        hist(intRvmP,  main="Omnibus interaction RVM p-values",
             breaks=c(0:40)/40, xlab="RVM p-value", cex.axis=cAx, cex.lab=cLab, cex.main=cMain)
        
        hist(intRvmPAdj,  main=tmpMain, breaks=c(0:40)/40, xlab="Adjusted RVM p-value",
             cex.axis=cAx, cex.lab=cLab, cex.main=cMain)
    }
    dev.off()    
}

anotaAdjustPvals <- function(pVals, correctionMethod){
    tmpAdj <- mt.rawp2adjp(as.vector(pVals), proc=correctionMethod)
    pAdj <- tmpAdj$adjp[order(tmpAdj$index),2]
    return(pAdj)
}
anotaAdjustPvalsQ <- function(pVals){
    tmpAdj <- qvalue(as.vector(pVals))
    pAdj <- as.vector(tmpAdj$qvalues)
    return(pAdj)
}
anotaPerformRVM <- function(MS, Df, residDf, residMS){
    ab <- anotaGetab(residMS, residDf)
    names(ab) <- c("a", "b")
    residMSRvm <- ((residDf*residMS)+2/ab[2])/(residDf+(2*ab[1]))
    residDfRvm <- residDf+2*ab[1]
    rvmFval <- MS / residMSRvm
    rvmP <- 1 - pf(rvmFval, Df, residDfRvm)
    return(list(residMSRvm=residMSRvm,
                residDfRvm=residDfRvm,
                rvmFval=rvmFval,
                rvmP=rvmP,
                ab=ab)
           )
}
anotaSlopeTest <- function(tmpLm, curSlope){
    tmpLmSum <- summary(tmpLm)
    if(curSlope<0){
        ##we are doing a one tailed test compared to the 2 tailed test in the output i.e. divide p by 2
        slopeP <- tmpLmSum$coefficients[2,4] / 2
    }
    if(curSlope>1){
        ##compare if slope is sig different to 1
        tmpSlopeEst <- tmpLmSum$coefficients[2,1] - 1
        tmpSlopeErr <- tmpLmSum$coefficients[2,2]
        tmpSlopeT <- tmpSlopeEst/tmpSlopeErr
        ##using resiual dfs to test p-value
        tmpSlopeDf <- tmpLm$df.residual
        slopeP <- 1-pt(tmpSlopeT, tmpSlopeDf)
    }
    return(slopeP)
}

anotaGetIntercepts <- function(x, y, slope, phenoLev, phenoVecOrg){
    tmpInt <- rep(NA, length(phenoLev))
    for(k in 1:length(phenoLev)){
        tmpX <- mean(x[phenoVecOrg==phenoLev[k]])
        tmpY <- mean(y[phenoVecOrg==phenoLev[k]])
        tmpInt[k] <- tmpY-(slope * tmpX)
    }
    return(tmpInt)
}

anotaPlotSingleRegression <- function(x, y, geneName, intercepts, slope, phenoVecOrg, phenoLev){
    plot(x=x, y=y, pch="", main=geneName)
    text(x=x, y=y, labels=phenoVecOrg)
    for(k in 1:length(phenoLev)){
        tmpMinX <- min(x, na.rm=TRUE)
        tmpMaxX <- max(x, na.rm=TRUE)
        lines(x=c(tmpMinX, tmpMaxX), y=c((intercepts[k] + slope*tmpMinX), (intercepts[k] + slope*tmpMaxX)),  lty=k)
    }
}

anotaPerformQcWarnings1 <- function(dataT=dataT, dataP=dataP, phenoVec=phenoVec){
    if(is.null(dataT)){
        cat("ERROR: No total RNA data\n")
        stop()
    }
    if(is.null(dataP)){
        cat("ERROR: No polysomal RNA data\n")
        stop()
    }
    if(is.null(phenoVec)){
        cat("ERROR: No phenotypes specified\n")
        stop()
    }
    if(identical(rownames(dataT), rownames(dataP))==FALSE){
        cat("ERROR: Polysomal and Total rownames do not follow the same order\nMake sure that the rownames are identical\n")
        stop()
    }
}

anotaPerformQcWarnings2 <- function(nPheno, phenoLev, phenoVecOrg, onlyGroup){
    ##require 3 samples per category unless using onlyGroup=TRUE
    for(i in 1:nPheno){
        if(sum(phenoVecOrg==phenoLev[i])<3){
            cat(paste(phenoLev[i], "only has", sum(phenoVecOrg==phenoLev[i]), "sample(s)"), "\n")
            if(onlyGroup==FALSE){
                cat("ANOTA requires 3 samples per sample class (in phenoVec) to run\n")
                cat("\tIf there is at least two samples per group and more than two groups, the onlyGroup mode can be used to assess omnibus group effects\n")
                stop()
            }
            if(onlyGroup==TRUE){
                if(sum(phenoVecOrg==phenoLev[i])==1){
                    cat("\tNo analysis can be run whith only one sample despite using the onlyGroup mode\n")
                    stop()
                }
                if(nPheno<3){
                    cat("\tThree sample classes is required to run the onlyGroup analysis when there is <3 samples per group")
                    stop()
                }
                if(nPheno>2){
                    cat("\tThere is only two samples in the sample class but >2 sample classes so onlyGroup analysis can be performed\n")
                }
            }
        }
    }
}

### R code from vignette source 'anota.Rnw'

###################################################
### code chunk number 1: anota.Rnw:135-142
###################################################
##Loading the library and data set, perform quality control and identify significant translational regulation. No RVM is applied in the example.
 library("anota")
 data(anotaDataSet)
 anotaQcOut <- anotaPerformQc(dataT=anotaDataT[1:200,], dataP=anotaDataP[1:200,], phenoVec=anotaPhenoVec, nDfbSimData=500, useProgBar=FALSE)
 anotaResidOut <- anotaResidOutlierTest(anotaQcObj=anotaQcOut, useProgBar=FALSE)
 anotaSigOut <- anotaGetSigGenes(dataT=anotaDataT[1:200,], dataP=anotaDataP[1:200,], phenoVec=anotaPhenoVec, anotaQcObj=anotaQcOut, useRVM=FALSE, useProgBar=FALSE)
anotaSelected <- anotaPlotSigGenes(anotaSigObj=anotaSigOut, selContr=1, maxP=0.1, minSlope=(-0.5), maxSlope=1.5, selDeltaPT=0.5)

#####################################################################
#####################################################################
anotaGetSigGenes <- function(dataT=NULL, dataP=NULL, phenoVec=NULL, anotaQcObj=NULL, correctionMethod="BH", contrasts=NULL, useRVM=TRUE, useProgBar=TRUE){
    ##Collect data set info
    phenoVecOrg <- phenoVec
    phenoVec <- as.factor(phenoVec)
    nPheno <- length(levels(phenoVec))
    phenoLev <- levels(phenoVec)
    nData <- dim(dataT)[1]
########################################################
    ##Warnings
    if(identical(rownames(dataT), rownames(dataP))==FALSE){
        cat("ERROR: Polysomal and Total rownames do not follow the same order\n")
        stop()
    }
    if(is.null(dataT)){
        cat ("ERROR: No data for total samples\n")
        stop()
    }
    if(is.null(dataP)){
        cat ("ERROR: No data for polysomal samples\n")
        stop()
    }
    if(is.null(phenoVec)){
        cat("ERROR: No phenotypes specified\n")
        stop()
    }
    ##analysis halts if user gives custom contrasts that are too few or too many.
    if(is.null(contrasts)==FALSE){
        if(dim(contrasts)[2]!=(nPheno-1)){
            if(dim(contrasts)[2]>(nPheno-1)){
                cat("Too many custom contrasts supplied.\nPlease check your contrast matrix\n")
                stop()
            }
            if(dim(contrasts)[2]<(nPheno-1)){
                cat("Too few custom contrasts supplied.\nPlease check your contrast matrix\n")
                stop()
            }
        }
    }
    cat("Running anotaGetSigGenes\n")
    if(is.null(contrasts)){
        cat("\tUsing default \"treatment\" contrasts between (custom contrasts can be set):\n")
        cat("\t", paste(levels(phenoVec)))
        cat("\n")
    }
##########################################################
    ##Create data structures
    residRvmDf <- apvP <- apvRvmP <- apvPAdj <- apvRvmPAdj <- apvEff <- apvMSerror <- apvRvmMSerror<- apvT<- apvF <- apvFP <- apvRvmF <- apvN <- apvRvmDf <- apvDf <- matrix(nrow=nData, ncol=nPheno-1)
    residDf  <- unadjustedResidError <-apvSlope <- apvSlopeP <- c(rep(NA, nData))

    rownames(apvP) <- rownames(apvRvmP) <- rownames(apvRvmDf)<- rownames(apvDf)<- rownames(apvEff) <- rownames(apvRvmF)<- rownames(apvRvmF) <- rownames(apvRvmMSerror) <- names(residDf)<- names(apvSlope) <- names(apvSlopeP) <- rownames(residRvmDf)  <- rownames(dataP)

##########################################################
    ##lm model without interaction
    total <- nData
    for(i in 1:nData){
        ##create a list object with data
        tmpList <- list("PolyRNA"=dataP[i,], "TotalRNA"=dataT[i,], "phenoType"=phenoVec)
        tmpApvSum <- c()
        tmpDim <- c()
        tmpApv <- c()
        ##add custom contrasts to the analysis
        if(is.null(contrasts)==FALSE){
            contrasts(tmpList$phenoType) <- contrasts
        }
        if(is.null(contrasts)==TRUE){
            ##if no specific contrasts are added. Extract the treatment contrasts
            ##change to our coding scheme (-1 for control instead of the standard 0)
            tmpCont <- contrasts(tmpList$phenoType)
            tmpCont[1,] <- (-1)
            contrasts(tmpList$phenoType) <- tmpCont
        }
        if(i==1){
            ##test that contrasts are correct
            tmpOut <- contrasts(tmpList$phenoType)
            tmpColSum <- apply(tmpOut, 2, sum)
            if(sum(tmpColSum==0)!=length(tmpColSum)){
                cat("\nERROR: Incorrect contrasts. Each column of the contrast matrix should sum to 0\n\n")
                stop()
            }
            colnames(tmpOut) <- paste("contrast", c(1:dim(tmpOut)[2]))
            cat("\tThese contrasts will be evaluated:\n\n")
            print(tmpOut)
            cat("\n")
            if(useProgBar==TRUE){
                pb <- txtProgressBar(min=0, max=total, style=3)
            }
        }
        
        attach(tmpList)
        tmpApv <- lm(PolyRNA~TotalRNA+phenoType)
        detach(tmpList)
        tmpApvSum <- summary(tmpApv)

        ##Get the residual error and slope and slope P
        tmpError <- tmpApvSum$sigma
        unadjustedResidError[i] <- tmpError
        tmpSlope <- tmpApvSum$coefficients[2,1]
        apvSlope[i] <- tmpSlope
        
        ##Set slope P to 1. If estimate is <0 or >1 this will be modified
        apvSlopeP[i] <- 1
        if(apvSlope[i]<0 | apvSlope[i]>1){
            apvSlopeP[i] <- anotaSlopeTest(tmpLm=tmpApv, curSlope=apvSlope[i])
        }
        contMat <- contrasts(tmpList$phenoType)
        ##Go through the contrast matrix column by column and perform analysis
        for(j in 1:dim(contMat)[2]){
            ##select all groups that do not have a 0 in the contrast matrix
            ##notice that contMatRed becomes a vector
            contMatRed <-contMat[contMat[,j]!=0,j]
            ##create a summary matrix with the adjusted means, the contrast and the covariate means
            tmpContMat <- matrix(nrow=length(contMatRed), ncol=4)
            rownames(tmpContMat) <- names(contMatRed)
            colnames(tmpContMat) <- c("contrast", "estimate", "groupN", "T_mean")
            for(k in 1:dim(tmpContMat)[1]){
                tmpGroup <- rownames(tmpContMat)[k]
                tmpEst <- mean(dataP[i,phenoVecOrg==tmpGroup]) - (tmpSlope * mean(dataT[i,phenoVecOrg==tmpGroup]))
                tmpCovMean <- mean(dataT[i,phenoVecOrg==tmpGroup])
                tmpContMat[k,"contrast"] <- contMatRed[k]
                tmpContMat[k,"estimate"] <- tmpEst
                tmpContMat[k,"groupN"] <- sum(phenoVecOrg==tmpGroup)
                tmpContMat[k,"T_mean"] <- tmpCovMean
            }
            ##Get the diff effect for the set of contrasts
            ##getpostitive contrsts means
            tmpContMatCopy <- tmpContMat
            ##set contrast sums to 1
            tmpContMatCopy[tmpContMatCopy[,"contrast"]>0,"contrast"] <- tmpContMatCopy[tmpContMatCopy[,"contrast"]>0,"contrast"] /
                sum(abs(tmpContMatCopy[tmpContMatCopy[,"contrast"]>0,"contrast"]))

            tmpContMatCopy[tmpContMatCopy[,"contrast"]<0,"contrast"] <- tmpContMatCopy[tmpContMatCopy[,"contrast"]<0,"contrast"] /
                sum(abs(tmpContMatCopy[tmpContMatCopy[,"contrast"]<0,"contrast"]))
            tmpDiffEff <- sum(tmpContMatCopy[,"contrast"] * tmpContMatCopy[,"estimate"])
            ##Get covariate error sums of squares
            lmT <- lm(dataT[i,]~as.factor(phenoVecOrg))
            lmTAov <- anova(lmT)
            tmpCovSS <- lmTAov[2,2]
            ##Get the covariate mean for all observations
            tmpCovMean <-  mean(dataT[i,])
            ##Get the corrected MSerror and the N term 
            tmpCov <- sum(tmpContMatCopy[,"contrast"]*(tmpContMat[,"T_mean"]-tmpCovMean))
            ##nTerm checked 
            tmpN <- sum(tmpContMatCopy[,"contrast"]*tmpContMatCopy[,"contrast"]/tmpContMat[,"groupN"])
            tmpErrorAdjusted <- tmpError * tmpError * c(tmpN + (tmpCov * tmpCov/tmpCovSS))
            ##Collect data of import
            apvMSerror[i,j] <- tmpErrorAdjusted
            apvEff[i,j] <- tmpDiffEff
            apvDf[i,j] <- 1
        }
        residDf[i] <- tmpApvSum$df[2]
        if(useProgBar==TRUE){
            setTxtProgressBar(pb, i)
        }
    }
    cat("\n\n")
########################################
    ##Statistics
    apvF <- apvEff  * apvEff  / apvMSerror
    ##calculate and correct P
    for(j in 1:(nPheno-1)){
        apvFP[,j] <- 1- pf(apvF[,j], apvDf[,j], residDf)
        if(correctionMethod!="qvalue"){
            apvPAdj[,j] <- anotaAdjustPvals(pVals=apvFP[,j], correctionMethod=correctionMethod)
           }
        if(correctionMethod=="qvalue"){
            apvPAdj[,j] <- anotaAdjustPvalsQ(pVals=apvFP[,j])
        }
    }
    ##Generate an significance LIST object. One table for each contrast
    statsList <- list()
    for(j in 1:dim(contMat)[2]){
        tmpMat <- cbind(apvSlope, apvSlopeP,  unadjustedResidError, apvEff[,j], apvMSerror[,j],  apvF[,j], residDf, apvFP[,j], apvPAdj[,j])
        colnames(tmpMat) <- c("apvSlope", "apvSlopeP",  "unadjustedResidError", "apvEff", "apvMSerror", "apvF", "residDf", "apvP", "apvPAdj")
        statsList[[j]] <- tmpMat
    }
    contrastMat <- contrasts(tmpList$phenoType)
    contrastNames <- colnames(contMat)
###########################################################
    ##RVM to each contrast
    abList <- list()
    statsListRvm <- list()
    if(useRVM==TRUE){
        cat("\tCalculating RVM statistics\n")
        jpeg("ANOTA_rvm_fit_for_all_contrasts_group.jpg", width=800, height=c((nPheno-1)*400), quality=100)
        par(mfrow=c(c(nPheno-1), 2))
        ##Get ab and modify MS and DFs per contrast
        for(j in 1:c(nPheno-1)){
            cat("\tAssessing contrast", j, "\n")
            anotaPlotIGFit(apvMSerror[,j], residDf[1], qqName=paste("Fit for contrast", j))            
            ##adjust the groupResidMSs based on the ab parameters
            tmpRVM <- anotaPerformRVM(MS=apvEff[,j]*apvEff[,j], Df=apvDf[,j], residDf=residDf, residMS=apvMSerror[,j])
            apvRvmMSerror[,j] <- tmpRVM$residMSRvm
            residRvmDf[,j] <-tmpRVM$residDfRvm
            apvRvmF[,j] <- tmpRVM$rvmFval
            apvRvmP[,j] <- tmpRVM$rvmP
            abList[[j]] <- tmpRVM$ab
            ##correct
            if(correctionMethod!="qvalue"){
                apvRvmPAdj[,j] <- anotaAdjustPvals(pVals=apvRvmP[,j], correctionMethod=correctionMethod)
            }
            if(correctionMethod=="qvalue"){
                apvRvmPAdj[,j] <- anotaAdjustPvalsQ(pVals=apvRvmP[,j])
            }
        }
        dev.off()
        
        ##Add new data to summary tables
        for(j in 1:dim(contMat)[2]){
            tmpMat <- cbind(apvSlope, apvSlopeP, apvEff[,j], apvRvmMSerror[,j], apvRvmF[,j], residRvmDf[,j], apvRvmP[,j], apvRvmPAdj[,j])
            tmpColnames <- c("apvSlope", "apvSlopeP", "apvEff", "apvRvmMSerror", "apvRvmF", "residRvmDf", "apvRvmP", "apvRvmPAdj")
            colnames(tmpMat) <- tmpColnames
            statsListRvm[[j]] <- tmpMat
        }
    }
    
########################################
    outputList <- list(
                       "apvStats" = statsList,
                       "apvStatsRvm" = statsListRvm,
                       "correctionMethod"=correctionMethod,
                       "usedContrasts"=contrastMat,
                       "abList"=abList,
                       "groupIntercepts"=anotaQcObj$groupIntercepts,
                       "inputData"=list("dataT"=dataT, "dataP"=dataP, "phenoVec"=phenoVec),
                       "useRVM"=useRVM
                       )
    
    return(outputList)
}

######################################################################
######################################################################
anotaPlotSigGenes <- function(anotaSigObj, selIds=NULL, selContr=NULL, minSlope=NULL, maxSlope=NULL, slopeP=NULL, minEff=NULL, maxP=NULL, maxPAdj=NULL, maxRvmP=NULL, maxRvmPAdj=NULL, selDeltaPT=NULL, selDeltaP=NULL, sortBy=NULL, performPlot=TRUE, fileName="ANOTA_selected_significant_genes_plot.pdf", geneNames=NULL){
    if(is.null(anotaSigObj)==TRUE){
        cat("No significant object")
        stop()
    }

    if(is.null(selContr)==TRUE){
        cat("No contrast selected")
        stop()
    }
    dataT <- anotaSigObj$inputData$dataT
    dataP <- anotaSigObj$inputData$dataP
    phenoVec <- anotaSigObj$inputData$phenoVec

    ##geneNames is a matrix with rownames accoring to the same rownames as in the data matrices and the first column containing an additional identifier which will be used as the main title for the plots.
    useGeneNames <- FALSE
    if(is.null(geneNames)==FALSE){
        useGeneNames <- TRUE
        tmp <- rownames(geneNames)
        geneNames <- as.vector(geneNames)
        names(geneNames) <- tmp
    }
        
    ##stop if no contrast
    if(selContr>dim(anotaSigObj$usedContrasts)[2]){
        cat ("ERROR: Specified contrast does not exist")
        stop()
    }
    tmpData <- anotaSigObj$apvStats[[selContr]]
    ##The analysis may not include RVM. Therefore the RVM needs to be optional
    tmpDataRvm <- NULL
    useRVM <- anotaSigObj$useRVM
    if(useRVM==TRUE){
        tmpDataRvm <- anotaSigObj$apvStatsRvm[[selContr]]
    }

    ##select which Ids that will be used. Can either be custom OR a combination of different thresholds and flags.
    ##user has supplied IDs through the selIds command
    if(is.null(selIds)==FALSE){
        useIds <- selIds
        tmpData <- tmpData[useIds,]
        if(useRVM==TRUE){
            tmpDataRvm <- tmpDataRvm[useIds,]
        }
    }
    if(is.null(selIds)==TRUE){
        ##reduce data to current thresholds
        if(is.null(minSlope)==FALSE){
            tmpData <- tmpData[tmpData[, "apvSlope"]>minSlope,]
            if(useRVM==TRUE){
                tmpDataRvm <- tmpDataRvm[tmpDataRvm[, "apvSlope"]>minSlope,]
            }
        }
        
        if(is.null(maxSlope)==FALSE){
            tmpData <- tmpData[tmpData[, "apvSlope"]<maxSlope,]
            if(useRVM==TRUE){
                tmpDataRvm <- tmpDataRvm[tmpDataRvm[, "apvSlope"]<maxSlope,]
            }
        }
        
        if(is.null(slopeP)==FALSE){
            tmpData <- tmpData[tmpData[, "apvSlopeP"]>slopeP,]
            if(useRVM==TRUE){
                tmpDataRvm <- tmpDataRvm[tmpDataRvm[, "apvSlopeP"]>slopeP,]
            }
        }
        
        if(is.null(minEff)==FALSE){
            tmpData <- tmpData[abs(tmpData[, "apvEff"])>minEff,]
            if(useRVM==TRUE){
                tmpDataRvm <- tmpDataRvm[abs(tmpDataRvm[, "apvEff"])>minEff,]
            }
        }
        
        if(is.null(maxP)==FALSE){
            tmpNames <- rownames(tmpData[tmpData[,"apvP"]<maxP,])
            tmpData <- tmpData[tmpNames,]
            if(useRVM==TRUE){
                tmpDataRvm <- tmpDataRvm[tmpNames,]
            }
        }
        
        if(is.null(maxPAdj)==FALSE){
            tmpNames <- rownames(tmpData[tmpData[,"apvPAdj"]<maxPAdj,])
            tmpData <- tmpData[tmpNames,]
            if(useRVM==TRUE){
                tmpDataRvm <- tmpDataRvm[tmpNames,]
            }
        }
        
        if(is.null(maxRvmP)==FALSE & useRVM==TRUE){
            tmpNames <- rownames(tmpDataRvm[tmpDataRvm[,"apvRvmP"]<maxRvmP,])
            tmpData <- tmpData[tmpNames,]
            tmpDataRvm <- tmpDataRvm[tmpNames,]
        }
        
        if(is.null(maxRvmPAdj)==FALSE & useRVM==TRUE){
            tmpNames <- rownames(tmpDataRvm[tmpDataRvm[,"apvRvmPAdj"]<maxRvmPAdj,])
            tmpData <- tmpData[tmpNames,]
            tmpDataRvm <- tmpDataRvm[tmpNames,]
        }
        
        ##if user selects RVM based filtering but did not run RVM analysis a warning is needed
        if((is.null(maxRvmP)==FALSE | is.null(maxRvmPAdj)==FALSE) & useRVM==FALSE){
            cat("WARNING: You have selected a RVM based filtering but did not perform RVM based analysis using anotaGetSigGenes.\nThis filtering is therefore ignored.\nIf you intend to use RVM based filtering please rerun anotaSigGenes with RVM enabled.\n")
        }
        
        if(dim(tmpData)[1]<1){
            cat("ERROR: No genes pass selected thresholds.\nTry to change the thresholds.\n")
            stop()
        }
        
        useIds <- rownames(tmpData)
    }

    
    ##Get some delta translation and delta transcription values
    phenoLev <- levels(as.factor(phenoVec))
    deltaT <- matrix(ncol=length(phenoLev), nrow=length(useIds))
    deltaP <- matrix(ncol=length(phenoLev), nrow=length(useIds))
    for(i in 1:length(useIds)){
        for(j in 1:length(phenoLev)){
            deltaT[i,j] <- mean(dataT[useIds[i],phenoVec==phenoLev[j]])
            deltaP[i,j] <- mean(dataP[useIds[i],phenoVec==phenoLev[j]])
        }
    }
    deltaPT <- deltaP - deltaT
    rownames(deltaP) <- rownames(deltaT) <- rownames(deltaPT) <- useIds
    colnames(deltaP) <- colnames(deltaT) <- colnames(deltaPT) <- phenoLev
    
    ##allow filtering based on deltaP and deltaPT but also get the delta data and return to user
    ##P
    tmp1 <- t(t(deltaP[useIds,]) * anotaSigObj$usedContrasts[,selContr])
    tmp2 <- apply(tmp1, 1, sum)
    deltaP <- tmp2
    if(is.null(selDeltaP)==FALSE){        
        tmp3 <- (tmp2 > selDeltaP & anotaSigObj$apvStats[[selContr]][useIds,"apvEff"]>0) | (tmp2 < (-selDeltaP) & anotaSigObj$apvStats[[selContr]][useIds,"apvEff"]<0)  
        useIds <- useIds[tmp3==TRUE]
        tmpData <- tmpData[useIds,]
        if(useRVM==TRUE){
            tmpDataRvm <- tmpDataRvm[useIds,]
        }
    }
    ##T
    tmp1 <- t(t(deltaT[useIds,]) * anotaSigObj$usedContrasts[,selContr])
    tmp2 <- apply(tmp1, 1, sum)
    deltaT <- tmp2
    
    ##PT
    tmp1 <- t(t(deltaPT[useIds,]) * anotaSigObj$usedContrasts[,selContr])
    tmp2 <- apply(tmp1, 1, sum)
    deltaPT <- tmp2
    if(is.null(selDeltaPT)==FALSE){
        tmp3 <- (tmp2 > selDeltaPT & anotaSigObj$apvStats[[selContr]][useIds,"apvEff"]>0) | (tmp2 < (-selDeltaPT) & anotaSigObj$apvStats[[selContr]][useIds,"apvEff"]<0)  
        useIds <- useIds[tmp3==TRUE]
        tmpData <- tmpData[useIds,]
        if(useRVM==TRUE){
            tmpDataRvm <- tmpDataRvm[useIds,]
        }
    }
    deltaP <- as.matrix(deltaP[useIds])
    deltaT <- as.matrix(deltaT[useIds])
    deltaPT <- as.matrix(deltaPT[useIds])
    colnames(deltaP) <- "deltaP"
    colnames(deltaT) <- "deltaT"
    colnames(deltaPT) <- "deltaPT"

    ##allow sorting based on user selection
    if(is.null(sortBy)==FALSE){
        if(sortBy=="Eff"){
            tmpSorter <- sort(tmpData[useIds,"apvEff"], decreasing=TRUE)
            useIds <- names(tmpSorter)
        }
        if(sortBy=="p"){
            tmpSorter <- sort(tmpData[useIds,"apvP"], decreasing=FALSE)
            useIds <- names(tmpSorter)
        }
        if(sortBy=="rvmP" & (useRVM==TRUE)){
            tmpSorter <- sort(tmpDataRvm[useIds,"apvRvmP"], decreasing=FALSE)
            useIds <- names(tmpSorter)
            
        }
        if(sortBy=="rvmP" & (useRVM==FALSE)){
            cat("WARNING: You have selected RVM based sorting but did not perform RVM based analysis using anotaGetSigGenes\nThis sorting is therefore ignored.\nIf you intend to use RVM based filtering please rerun anotaSigGenes with RVM enabled.\n")
        }
    }
    
    ##Generate plots for those Ids that are left
    ##plotting is optional
    if(performPlot==TRUE){
        pdf(fileName, width=12, height=12)
        par(mfrow=c(3,3))

        for(i in 1:length(useIds)){
            tmpSlope <- anotaSigObj$apvStats[[1]][useIds[i], "apvSlope"]
            tmpTmin <- min(dataT[useIds,])
            tmpTmax <- max(dataT[useIds,])
            tmpPmin <- min(dataP[useIds,])
            tmpPmax <- max(dataP[useIds,])
            mainTitle <- paste(useIds[i], "Slope:", round(tmpSlope, digits=2))
            if(useGeneNames==TRUE){
                mainTitle <- paste(useIds[i], geneNames[useIds[i]], "Slope:", round(tmpSlope, digits=2))
            }
            plot(y=c(tmpPmin, tmpPmax), x=c(tmpTmin, tmpTmax), pch="", main=mainTitle, xlab="Transcription", ylab="Translation")
            phenoLev <- levels(as.factor(phenoVec))
            for(j in 1:length(phenoLev)){
                text(y=dataP[useIds[i],phenoVec==phenoLev[j]], x=dataT[useIds[i],phenoVec==phenoLev[j]], labels=phenoVec[phenoVec==phenoLev[j]], col=j)   
                tmpT <- mean(dataT[useIds[i],phenoVec==phenoLev[j]])
                tmpP <- mean(dataP[useIds[i],phenoVec==phenoLev[j]])
                tmpInt <- tmpP-(tmpSlope * tmpT)
                lines(x=c(tmpTmin, tmpTmax), y=c((tmpInt + tmpSlope*tmpTmin), (tmpInt + tmpSlope*tmpTmax)),  col=j)
            }
        
            ##add some stats for each contrast
            deltaLine <- 1
            deltaLine2 <- 0.5
            xShift <- 4
            ##no RVM
            plot(y=c(0, 10), x=c(0, 10), main=paste(useIds[i], "APV statistics without RVM"), pch="", xaxt="n", yaxt="n", xlab="", ylab="")
            nCont <- dim(anotaSigObj$usedContrasts)[2]
            lineCount <- 10
            xPos <- 2
            for(j in 1:nCont){
                sampCl1 <- rownames(anotaSigObj$usedContrasts)[anotaSigObj$usedContrasts[,j]<0]
                sampCl2 <- rownames(anotaSigObj$usedContrasts)[anotaSigObj$usedContrasts[,j]>0]
                tmpEff <- anotaSigObj$apvStats[[j]][useIds[i], "apvEff"]
                tmpP <- anotaSigObj$apvStats[[j]][useIds[i], "apvP"]
                tmpPadj <- anotaSigObj$apvStats[[j]][useIds[i], "apvPAdj"]
                text(y=lineCount, x=xPos, labels=paste("Contrast:", j), font=2, cex=1.2)
                lineCount <- lineCount - deltaLine2
                ##disabled because of problems with long contrast names or when several classes are combined to one
                ##text(y=lineCount, x=xPos, labels=paste(sampCl2, "vs.", sampCl1))
                ##lineCount <- lineCount - deltaLine2
                text(y=lineCount, x=xPos, labels=paste("Effect:", round(tmpEff, digits=2)))
                lineCount <- lineCount - deltaLine2
                text(y=lineCount, x=xPos, labels=paste("p-value:", round(tmpP, digits=4)))
                lineCount <- lineCount - deltaLine2
                text(y=lineCount, x=xPos, labels=paste("adjusted p-value:", round(tmpPadj, digits=3)))
                lineCount <- lineCount -deltaLine
                if(lineCount<3){
                    lineCount=10
                    xPos = xPos + xShift
                }
            }
            ##with RVM
            plot(y=c(0, 10), x=c(0, 10), main=paste(useIds[i], "APV statistics with RVM"), pch="", xaxt="n", yaxt="n", xlab="", ylab="")
            if(useRVM==TRUE){
                nCont <- dim(anotaSigObj$usedContrasts)[2]
                lineCount <- 10
                xPos <- 2
                for(j in 1:nCont){
                    sampCl1 <- rownames(anotaSigObj$usedContrasts)[anotaSigObj$usedContrasts[,j]<0]
                    sampCl2 <- rownames(anotaSigObj$usedContrasts)[anotaSigObj$usedContrasts[,j]>0]
                    tmpEff <- anotaSigObj$apvStatsRvm[[j]][useIds[i], "apvEff"]
                    tmpP <- anotaSigObj$apvStatsRvm[[j]][useIds[i], "apvRvmP"]
                    tmpPadj <- anotaSigObj$apvStatsRvm[[j]][useIds[i], "apvRvmPAdj"]
                    text(y=lineCount, x=xPos, labels=paste("Contrast:", j), font=2, cex=1.2)
                    lineCount <- lineCount - deltaLine2
                    ##disabled because of problems with long contrast names or when several classes are combined to one
                    ##text(y=lineCount, x=xPos, labels=paste(sampCl2, "vs.", sampCl1))
                    ##lineCount <- lineCount - deltaLine2
                    text(y=lineCount, x=xPos, labels=paste("Effect:", round(tmpEff, digits=2)))
                    lineCount <- lineCount - deltaLine2
                    text(y=lineCount, x=xPos, labels=paste("p-value:", round(tmpP, digits=4)))
                    lineCount <- lineCount - deltaLine2
                    text(y=lineCount, x=xPos, labels=paste("adjusted p-value:", round(tmpPadj, digits=3)))
                    lineCount <- lineCount -deltaLine
                    if(lineCount<3){
                        lineCount=10
                        xPos = xPos + xShift
                    }
                }
            }
        }
        dev.off()
    }
    tmpDataOut <- tmpData[useIds,]
    tmpDataRvmOut <- NULL
    if(useRVM==TRUE){
        tmpDataRvmOut <- tmpDataRvm[useIds,]
    }
    ##Generate output
    sigGroupIntercepts <- anotaSigObj$groupIntercepts[useIds,]
    tmpOut <- list("selectedData"=tmpDataOut,
                   "selectedRvmData"=tmpDataRvmOut,
                   "groupIntercepts"=sigGroupIntercepts[useIds,],    
                   "deltaData"=cbind("deltaP"=deltaP[useIds,], "deltaT"=deltaT[useIds,], "deltaPT"=deltaPT[useIds,]),                   
                   "usedThresholds" = list(
                   "selContr" = selContr,
                   "minSlope" = minSlope,
                   "maxSlope" = maxSlope,
                   "slopeP" = slopeP,
                   "minEff" = minEff,
                   "maxP" = maxP,
                   "maxPAdj" = maxPAdj,
                   "maxRvmP" = maxRvmP,
                   "maxRvmPAdj" = maxRvmPAdj,
                   "selDeltaPT" = selDeltaPT,
                   "selDeltaP" = selDeltaP)
                   )
    return(tmpOut)
}

#############################################################################
#############################################################################
anotaPlotIGFit <- function(useVar, df, title="Empirical", doQQ=TRUE, qqName=NULL) {
    ##Internal fuctions in anotaPlotIGFit
    ## Generate empirical probability density function for data.
    ## data - vector of data points
    ## q - trimming value.  remove 1-q points as outliers from greater tail.                                    
    my.cum <- function(data, q=.9) {
        len <- getLen(data, quan=q)
        maxi <- sort(data)[len]
        x <- seq(min(data), maxi, length=len)
        p <- rep(0,len-1)
        lenny <- length(data)
        for(i in 1:len)
            p[i] <- (sum(data<x[i]))/lenny
        return(cbind(x, p))
    }
#####################################
    flik <- function(p,y){
        ## log liklihood for a*b*x from an F distribution with m and 2*a degrees of freedom
        ## y is a vector containing data and the m values, p contains a and b.
        x<-y[1:(length(y)/2)]
        m<-y[(length(y)/2+1):length(y)]
        p<-abs(p)
        a<-p[1]
        b<-p[2]
        x<-x*(a*b)
        n<-2*a
        out<-base::log(df(x,m,n))+base::log(a*b)
        sum(-out)
    }
######################################
    ## Get rid of the very large data points so graphs scale better
    ## quan - trimming quantile
    getLen <- function(data, quan=.90) {
        return(trunc(quan*length(data)))
    }    
######################################
    degFreedom1 <- df
    vars <- as.vector(useVar)
    ab <- anotaGetab(vars, rep(degFreedom1, length(vars)))
    cat("\tThe a and b parameters for the inverse gamma distribution are:\n\t", paste(c("a:",ab[1], "b:", ab[2])), "\n")
    adj <- ab[1]*ab[2]
    adjVars <- vars*adj[1]
    scum <- my.cum(adjVars, q=0.9)
    probF <- pf(scum[,1], degFreedom1, 2*ab[1])
    lineWidth <- 2
    if(doQQ) {
        num <- length(adjVars)
        theoF <- rf(num, degFreedom1, df2=2*ab[1])
        qqplot(theoF, adjVars,xlab="Theoretical", ylab="Empirical", main=qqName)
        abline(0,1)
    }
    ##Turn off warnings temporary as there is always an informative warning message
    options(warn=(-1))
    kRes <- ks.test(x=adjVars, y="pf", degFreedom1, 2*ab[1])$p.value
    options(warn=0)
    plot(scum[,1], scum[,2], type="l", lwd=lineWidth, xlab="Var", ylab="cdf",
         main=paste(title, ": KS p-value=", signif(kRes,3), sep=""))
    lines(scum[,1], scum[,2], col=2)
    lines(scum[,1], probF, col=5, lwd=lineWidth)
    legend(x=c(1), y=c(0.3),  legend=c( title, "Theoretical F"), fill=c(2,5))
    options(warn=(1))
}

#############################################################################
#############################################################################
anotaGetab <- function(sig,n){
    flik <- function(p,y){
        ## log liklihood for a*b*x from an F distribution with m and 2*a degrees of freedom
        ## y is a vector containing data and the m values, p contains a and b.
        x<-y[1:(length(y)/2)]
        m<-y[(length(y)/2+1):length(y)]
        p<-abs(p)
        a<-p[1]
        b<-p[2]
        x<-x*(a*b)
        n<-2*a
        out<-base::log(df(x,m,n))+base::log(a*b)
        sum(-out)
    }
    set<-(!is.na(sig)&n>0&sig>0)
    sig<-sig[set]
    n<-n[set]
    set<-n>4
    if (sum(set)>0){
        m1<-(n[set]-2)/((n[set])*sig[set])
        m2<-(n[set]-2)*(n[set]-4)/((n[set])*sig[set])^2
        m1<-mean(m1,na.rm=TRUE)
        m2<-mean(m2,na.rm=TRUE)
        b<-m2/m1-m1
        a<-m1^2/(m2-m1^2)
    }
    else{ a<-b<-1}
    strt<-c(a,b)
###PATCH
    g <- function(p,yunq) flik(p,yunq)
########
    options(warn=(-1))
    a<-nlm(g,strt, yunq=c(sig,n))
    options(warn=0)
    a$estimate<-abs(a$estimate)
}

anotaResidOutlierTest <- function(anotaQcObj=NULL, confInt=0.01, iter=5, generateSingleGraph=FALSE, nGraphs=200, generateSummaryGraph=TRUE, residFitPlot=TRUE, useProgBar=TRUE){
    ##Get data
    residualMatrix <- anotaQcObj$residuals
    nData <- dim(residualMatrix)[1]
    geneNames <- rownames(residualMatrix)
######################################################
    ##Warnings
    if(is.null(residualMatrix)){
        cat("ERROR:No residuals as input\n")
        stop()
    }
######################################################
    ##Single gene plotting
    if(generateSingleGraph==TRUE){
        pdf("ANOTA_residual_distributions_single.pdf", width=9, height=12)
        par(mfrow=c(4,3))
    }
######################################################
    ##Data structures
    residualMatrixOutlierSum <- matrix(ncol=iter, nrow=nData, dimnames=list("rownames"=rownames(residualMatrix)))
    residualMatrixOutlier <- matrix(ncol=dim(residualMatrix)[2], nrow=nData, dimnames=list("rownames"=rownames(residualMatrix), "colnames"=colnames(residualMatrix)))
    allSortScaleTrue <- allXs <- matrix(nrow=dim(residualMatrix)[2], ncol=nData)
    residualMatrixOutlierSumP <- rep(NA, iter)
##############################################
    ##Run analysis using the set n iterations
    cat("Running anotaResidOutlierTest\n")
    total <- iter
    if(useProgBar==TRUE){
        pb <- txtProgressBar(min=0, max=total, style=3)
    }
    for(j in 1:iter){
        if(useProgBar==TRUE){
            setTxtProgressBar(pb, (j))
        }
        ##generate the random normally distributed data. 
        rnormMat <- matrix(data=rnorm(dim(residualMatrix)[2]*((1/confInt)-1)),
                           nrow=dim(residualMatrix)[2], ncol=((1/confInt)-1))

        ##Calculate the upper and lower limits of the data and scale
        rnormMat <- apply(scale(rnormMat),2,sort)
        env <- t(apply(rnormMat, 1, range))
        for(i in 1:nData){            
            ##Scale true data per gene sort and cbind to rnorm data set
            trueVec <- sort(scale(residualMatrix[i,]))
            sampMat <- cbind(trueVec, rnormMat)
            ##get real data set qq
            rs <- sampMat[,1]
            xs <- qqnorm(rs, plot=FALSE)$x
            ##get range of the sampled distribution sort position
            ##Calculate if obtained residuals falls outside expected from rnorm
            rsLog <- rs<env[,1] | rs>env[,2]
            residualMatrixOutlierSum[i,j] <- sum(rsLog)
            residualMatrixOutlier[i,] <- rsLog
            ##save true data
            allSortScaleTrue[,i] <- trueVec
            allXs[,i] <- xs
            if(iter==j & generateSingleGraph==TRUE & nGraphs>=i){
                anotaResidOutlierPlot(xs=xs, rs=rs, env=env, geneName=geneNames[i])
            }
            
        }
        ##Collect data for single
        residualMatrixOutlierSumP[j] <- sum(residualMatrixOutlier>0)
    }
    cat("\n\n")
    if(generateSingleGraph==1){
        dev.off()
    }
################################################
    ##calcaulte obtained expected
    ##only create full summary for last iteration
    residualMatrixOutlierLog <- residualMatrixOutlier>0
    residualMatrixOutlierSumP <- residualMatrixOutlierSumP/(nData*dim(residualMatrixOutlier)[2])
    obtVsExpected <- residualMatrixOutlierSumP[j]/confInt
    expected <- nData *dim(residualMatrixOutlier)[2] *confInt
    obtained <- sum(residualMatrixOutlierLog)
################################################
    outputList <- list(
                       "confInt"=confInt,
                       "inputResiduals"=residualMatrix,
                       "rnormIter"=iter,
                       "outlierMatrixLog"=residualMatrixOutlierLog,
                       "meanOutlierPerIteration"=residualMatrixOutlierSumP,
                       "obtainedComparedToExpected"=obtVsExpected,
                       "nExpected"=expected,
                       "nObtained"=obtained)
#################################################
    ##Plotting summary
    if(generateSummaryGraph==TRUE){
        jpeg("ANOTA_residual_distribution_summary.jpeg", width=800, height=800, quality=100)
        anotaResidOutlierPlotAll(all=allSortScaleTrue, xsAll=allXs, env=env, obtained=obtained, expected=expected, obtRelExpected=obtVsExpected, confInt=confInt)
        dev.off()
    }
    ##plot fitted vs residuals
    if(residFitPlot==TRUE){
        jpeg("ANOTA_residual_vs_fitted.jpeg", width=900, height=900, quality=100)
        par(mfrow=c(2,1))
        plot(x=as.vector(anotaQcObj$fittedValues), y=as.vector(anotaQcObj$residuals), ylab="residuals", xlab="Fitted values", main="Residual vs fitted values")
        dev.off()
    }
    return(outputList)   
}


#################################################################################
#################################################################################
anotaResidOutlierPlot <- function(rs=NULL, xs=NULL, env=NULL, geneName=""){  
    matplot(xs, cbind(rs, env), type="pnn", pch=4, mkh=0.06, axes=FALSE, xlab="", ylab="", main=geneName)
    ##gets the limits and calculate lengths for the bars that mark the boundaries of the envelope
    xyul <- par("usr")
    smidge <- min(diff(c(xyul[1], xs, xyul[2])))/2
    segments(xs-smidge, env[,1], xs+smidge, env[,1])
    segments(xs-smidge, env[,2], xs+smidge, env[,2])
    ##get axis with nice ticks
    xul <- trunc(10*xyul[1:2])/10
    axis(side=1, at=seq(xul[1], xul[2], by=0.1), labels=FALSE, tck=0.01)
    xi <- trunc(xyul[1:2])
    axis(side=1, at=seq(xi[1], xi[2], by=0.5), tck=0.02)
    yul <- trunc(5*xyul[3:4])/5
    axis(side=2, at=seq(yul[1], yul[2], by=0.2), labels=FALSE, tck=0.01)
    yi <- trunc(xyul[3:4])
    axis(side=2, at=yi[1]:yi[2], tck=0.02)
    box(bty="l")
    mtext("Quantiles of Standard Normal", side=1, line=2.5, font=3)
    mtext(expression(R[1]), side=2, line=2, at=yul[2])
}

#####################################################################
#####################################################################
anotaResidOutlierPlotAll <- function(all=NULL, xsAll=xsAll,  env=env, obtained, expected, obtRelExpected, confInt){
    allMax=max(all)
    allMin=min(all)
    xsMin=min(xsAll)
    xsMax=max(xsAll)
    ##Get number of outliers per rankposition
    allLog <- all<env[,1] | all>env[,2]
    allLogSum <- apply(allLog, 1, sum)
    allLogSumP <- 100*(allLogSum / dim(allLog)[2])
    allLogSumP <- round(allLogSumP, digits=3)
    ##plot
    plot(x=c(xsMin,xsMax), y=c(allMin-0.2, allMax+0.4), pch="", axes=TRUE, xlab="Quantiles of standard normal", ylab="R", main="Summary of all residuals")
    for(i in 1:dim(all)[2]){
        points(x=xsAll[,i], y=all[,i], pch=16, cex=0.2)
    }
    if(is.null(obtained)==FALSE){
        text(x=xsMin+0.4, y=allMax-0.4-(0.05*allMax), labels=paste("Expected outliers: ", confInt*100, "%", sep=""))
        text(x=xsMin+0.4, y=allMax-0.4-(0.1*allMax), labels=paste("Obtained outliers: ", round(obtRelExpected*confInt*100, digits=3), "%", sep=""))
    }
    segments(xsAll[,i]-0.05, env[,1], xsAll[,i]+0.05, env[,1], col=2, lwd=1.5)
    segments(xsAll[,i]-0.05, env[,2], xsAll[,i]+0.05, env[,2], col=2, lwd=1.5)
    text(x=xsAll[,1], y=env[,2]+0.2, labels=paste(allLogSumP, "%", sep=""))
}

%\VignetteIndexEntry{ANalysis Of Translational Activity (anota)}
%\VignetteKeywords{Translation, ANCOVA}
%\VignettePackage{anota}

\documentclass[12pt]{article}
\usepackage{amsmath}
\usepackage{hyperref}
\usepackage{url}
\usepackage{isorot}
\usepackage{epsfig}
\usepackage{fullpage} % standard 1 inch margins 

\newcommand{\Robject}[1]{{\texttt{#1}}}
\newcommand{\Rfunction}[1]{{\texttt{#1}}}
\newcommand{\Rpackage}[1]{{\textit{#1}}}
\newcommand{\Rclass}[1]{{\textit{#1}}}
\newcommand{\Rmethod}[1]{{\textit{#1}}}
\newcommand{\code}[1]{\texttt{#1}}
\newcommand{\email}[1]{\texttt{#1}}


\usepackage{Sweave}
\begin{document}
\title{ANalysis Of Translational Activity (anota)}
\author{
  Ola Larsson
  \email{<ola.larsson@ki.se>}, \\
  Nahum Sonenberg
  \email{<nahum.sonenberg@mcgill.ca>},\\
  Robert Nadon
  \email{<robert.nadon@mcgill.ca>}
}

\maketitle
\tableofcontents


\section{Introduction}
Translational control of gene expression is a mechanism that affects the relationship between mRNA level and protein level. Translation is commonly deregulated in human diseases such as cancer and understanding which mRNAs are targeted for translational deregulation and the mechanisms that mediate such effects is of high importance. Estimates of global translational activity has primarily been generated using the poly(ribo)some microarray approach (reviewed in \cite{Larsson1}) but sequencing based methods have also recently been developed \cite{seqRef}. Both approaches are based on a parallel quantification of cytosolic mRNA level and the level of those mRNAs that are actively utilized for translation. During poly(ribo)some preparations, the cytosolic mRNA is isolated and separated based on the number of  associated ribosomes. Fractions of mRNAs associated with several ribosomes are pooled and designated the translationally active pool. A parallel cytosolic mRNA sample, which is used to assess the cytosolic mRNA level, is also collected. More details are found in \cite{Larsson1}. The recent sequencing based method utilizes the ribosome protection assay where the mRNA part that is bound to a ribosome is resistant to mild RNA degradation treatment and mRNA fragments, which correspond to the expected size that is protected from degradation (hence bound to ribosomes and actively translated), are isolated. This sample is similar to the actively translated sample from the polysome microarray approach. Analogous to the cytosolic mRNA sample that is isolated during the polysome microarray approach, a parallel sample which has been processed similarly but without applying the protection assay is also collected. Thus, both approaches generate two data types, one from cytosolic mRNA and a second from actively translating mRNA.\\

After isolation of cytosolic mRNA and translationally active mRNA, both samples are labelled and probed with microarrays in the case of the polysome microarray approach or subjected to deep sequencing in the case of the ribosome profiling approach. The result for both methods is, sample per sample, data for cytosolic mRNA level and data for translationally active mRNA. In the simplest case, changes in translational control between two sample classes could be assessed by comparing the data obtained from the translationally active mRNA. However, a change in transcription, mRNA transport from the nucleus to the cytosol or mRNA stability would be expected to also lead to changes in the data derived from translationally active mRNA despite being unrelated to translational activity. It is therefore necessary to correct for differences in the cytosolic mRNA pool when comparing data from translationally active mRNA. To date, correction has primarily been performed by creating per sample differences (log scale) between the translationally active mRNA level and the cytosolic mRNA level \cite{Larsson1}. These have then been compared directly between sample classes. However, as discussed in \cite{Larsson3} the corrected values often show spurious correlation to the data derived from the cytosolic mRNA. There are also several examples of where the log ratio approach will lead to false conclusions \cite{Larsson3}.\\

Most of these problems can be solved by using regression analysis between the translationally active mRNA levels and the cytosolic mRNA levels. Such analysis produces residuals that are uncorrelated with the cytosolic mRNA levels and differential translation can be identified using Analysis of Partial Variance (APV) \cite{Larsson3}. However, to apply linear regressions and APV, various assumptions need to be fulfilled for tens of thousands of genes, thus offering substantial challenges. Due to the high dimensionality of the data, anota takes multiple testing into account when assessing assumption violations. If we observe the same number of problematic features as expected, we assume that we can apply anota.\\

The first issue that needs consideration is the appearance of highly influential data points which may cause errors in the regression analyses. On the one hand, we expect that a number of highly influential data points will appear merely by chance because of the large number of analyses performed. Thus we attempt to establish if we, when considering all analysed genes, observe more influential data points compared to what would be expected by chance. If the answer is no, then there are no concerns with the overall analysis.  On the other hand, influential data points may nonetheless affect the specific APV analyses in which they are found.  For this reason, anota provides an output that can be used to flag these results so that they can be examined in more detail if desired. 

For detection of influential data points, anota uses standardized dfbeta for the slope of the regression and several thresholds to determine whether or not a data point is highly influential. As there is no known distribution of the dfbetas when the underlying data are normally distributed, anota simulates data sets to obtain estimates of the expected number of outliers. The simulation is performed by sampling N (corresponding to the number of samples in the analysis) data points from the normal distribution and calling these data points the cytosolic mRNA level. The translationally active mRNA levels are obtained by sampling data points from a normal distribution with a mean of the cytosolic mRNA level for each cytosolic mRNA level data point. Ten different such data sets are obtained with different variances when sampling the translationally active mRNA level data. These data sets are then merged and frequencies of outlier dfbetas are calculated and compared to the frequencies of outlier dfbetas from the analyzed data. This level of quality control is performed in the \code{anotaPerformQc} function.\\

A second issue concerns the APV assumption that the slopes of the regressions from each sample class are the same so that using the common slope is valid. This assumption postulates that the relationship between the translationally active mRNA level and the cytosolic mRNA level shows the same slope for each sample class, i.e., sample class and cytosolic mRNA levels do not interact in predicting translation mRNA levels. Again, because we analyse tens of thousands of regressions, we expect that a number of interactions will arise simply due to chance. If the number of interactions does not exceed what is expected by chance, their p-values should follow a uniform NULL distribution. Thus the second level of quality control compares the distribution of the interaction significances as well as the distribution after adjusting the interaction p-values for multiple testing. This level of quality control is performed in the \code{anotaPerformQc} function.\\

The third issue relates to the significance testing within the APV framework which assumes that the residuals from the regressions are normally distributed. The \code{anotaResidOutlierTest} function assesses whether the residuals from the linear regressions (gene by gene) of translationally active mRNA level~cytosolic mRNA level are normally distributed. anota generates normal Q-Q plots of the residuals.  If the residuals are normally distributed, the data quantiles will form a straight diagonal line from bottom left to top right.  Because there are typically relatively few data points, anota calculates ''envelopes'' based on a set of samplings from the normal distribution using the same number of data points as for the true data \cite{MAS}. To enable a comparison both the true and the sampled data are scaled (variance=1) and centered (mean=0). The samples (both true and sampled) are then sorted and the true sample is compared to the envelopes of the sampled series at each sort position. The result is presented as a Q-Q plot of the true data where the envelopes of the sampled series are indicated. If there are 99 samplings we expect that 1/100 values should be outside the range obtained from the samplings. Thus it is possible to assess if approximately the expected number of outlier residuals are obtained.\\

The slopes that are used within anota can take unrealistic values that will influence the analysis of differential translation. These are random events that are likely to be more common when fewer samples and fewer sample classes are analysed. anota therefore tests whether slopes that are <0 (representing unlikely but not impossible translational control \cite{Larsson3}) or >1 (slopes >1 are not realistic) differ from 0 and 1 respectively and reports a p-value in the output of the \code{anotaPerformQc} and \code{anotaGetSigGenes} functions. This p-value can be used to filter or flag genes with unrealistic slopes.\\

While anota enables testing of the issues discussed above it is left to the user to decide whether it is possible to use anota to identify differential translation. A few issues that may cause problems in the quality control are:

\begin{enumerate}
\item Outlier samples. One or a few outlier samples in the analysis (either from the translation data or the cytosolic mRNA data) could give rise to many influential data points. Thus, if there are more influential data points than would be expected, a careful quality control of the data followed by identification and exclusion of outlier samples might be needed to resolve such issues.
  \item More significant interactions compared to what is expected by chance could be caused by bias in the data set. One essential component during the polysome preparations is the consistent isolation of the same stratum of the polysomes across all samples (i.e., so that the >n ribosome threshold is met when pooling fractions, not >n+1 or >n-1) because the cut off point will influence the slope. A systematic error in the cut off  could cause a high abundance of interactions. If one retrospectively can go back and assess which samples may have error in the cut off one could try to either remove these or use established methods to remove systematic bias.
\item If the resulting residuals deviate strongly from normality an alternative normalization method could be tested.
\end{enumerate}

\section{Data set quality control in anota}
The \code{anotaPerformQc} checks whether the data set shows the expected number of highly influential data points and whether there are more significant interactions compared to what is expected by chance. \code{anotaPerformQc} can also output a set of identifier per identifier regressions (not default) which may be a good approach to see how well regressions seem to work (\ref{singleReg}). 

\begin{figure}[tbp]
  \includegraphics[]{fig//singleReg.pdf}
  \caption{anota can be set to output identifier per identifier regressions between translationally active and cytosolic mRNA levels. Plotting symbols are taken from the \code{phenoVec} argument and the lines are the regressions lines per samples class}
  \label{singleReg}
\end{figure}


Further, anota generates an output from the influential data point analysis where the obtained number of influential data points using several suggested thresholds are compared to a simulated data set \ref{dfbs}.


\begin{figure}[tbp]
  \includegraphics[]{fig//dfbs.pdf}
  \caption{A bar graph showing the obtained and expected (based on a simulation) number of influential data points as judged by different thresholds. For each threshold the difference between the obtained and the simulated frequency of outliers is shown.}
  \label{dfbs}
\end{figure}

anota also generates an output from the analysis of interactions \ref{int}. Here the distribution of the obtained interaction significances is assessed to examine if these follow the uniform NULL distribution.

\begin{figure}[tbp]
  \includegraphics[]{fig//int.pdf}
  \caption{Assessment of whether the significances for the interactions follow the uniform NULL distribution. Shown are both density plots and histograms of the nominal and adjusted p-values (in this case adjusted using Benjamini-Hochberg FDR).}
  \label{int}
\end{figure}

anota also allows for examination of the residuals from the linear regression within the \code{anotaResidOutlierTest}. As discussed in the introduction, the test allows for examination if the residuals are approximately normally distributed. The single identifier output from \code{anotaResidOutlierTest} is shown in figure \ref{residSingle} and the summary output output  is shown in figure \ref{resid}.

Finally, as described above, anota reports p-values for unlikely or unrealistic slopes which can be used to filter or flag genes.

\begin{figure}[tbp]
  \includegraphics[]{fig//residSingle.pdf}
  \caption{Assessment of whether the residuals are approximately normally distributed. Shown is the output from the single identifier alternative within \code{anotaResidOutlierTest}. The Q-Q plot for the identifier is compared to the outer limits of a set of Q-Q plots generated by sampling from the normal distribution (described further in the introduction).}
  \label{residSingle}
\end{figure}

\begin{figure}[tbp]
  \includegraphics[]{fig//resid.jpg}
  \caption{Assessment of whether the residuals are approximately normally distributed. Shown is the output from all identifiers using the \code{anotaResidOutlierTest} function. The Q-Q plot for the identifiers is compared to the outer limits of a set of Q-Q plots generated by sampling from the normal distribution (described further in the introduction). The obtained and expected percentage of outliers is indicated at each rank position and combined.}
  \label{resid}
\end{figure}

\section{Using anota to identify differential translation}
Once the data set has been validated as suitable for analysis, significant translational regulation is identified. \code{anotaPerformQc} performs an omnibus group effect test when there are more than 2 sample classes. Within the \code{anotaGetSigGenes} the user can set custom contrasts to identify significantly differentially translated genes. The output from \code{anotaGetSigGenes} can be visualized and filtered using the \code{anotaPlotSigGenes} function to generate both a summary table and per gene plots. The graphical output shows both the graphical interpretation of the APV analysis and the key statistics from both the standard and the RVM based analysis \ref{plotSigOut}. See the function descriptions within the anota R package for each function for more details. 

\begin{figure}[tbp]
  \includegraphics[]{fig//anotaPlotSigOut.pdf}
  \caption{The output from the \code{anotaPlotSigGenes} function. The left graph shows the identifier per identifier regressions between translationally active and cytosolic mRNA levels. Plotting symbols are taken from the \code{phenoVec} argument supplied to the \code{anotaGetSigGenes} function and the lines are the regression lines per sample class using the common slope identified in APV (shown in the main title). The right and middle graphs show key statistics for the analyzed gene with and without RVM respectively. When there is more than one contrast all contrasts will be shown but any filterings defined within the \code{anotaPlotSigGenes} function will be applied to the selected contrast only.}
  \label{plotSigOut}
\end{figure}


 
\begin{figure}[tbp]
  \includegraphics[]{fig//rvm.jpg}
  \caption{A comparison of the obtained variances to the theoretical F-distribution. RVM assumes that the empirical and the theoretical distributions are similar.}
  \label{rvm}
\end{figure}


\section{Random variance model (RVM) to improve power in detection of differential translational activity within anota}
RVM is an empirical Bayes method which has been shown to increase statistical power for small N analysis \cite{rvm}. In RVM, the within gene variance is adjusted using the variance obtained from an inverse gamma distribution derived from the variances of all genes. A key assumption in RVM is that the resulting variances follow a theoretical F-distribution. anota test this for the analysis of omnibus interactions, omnibus group effects and the identification of differential translational activity. Each of these analyses generates a comparison of the obtained empirical distribution compared to the theoretical distribution (similarity assessed using a KS test which NULL hypothesis should not be rejected for a good fit). We have noticed that the normalization of the data can strongly influence the fit but that RVM seems to be applicable in most cases. It is necessary to validate that application of RVM does not influence the distribution of the interaction p-values. Figure \ref{rvm} shows the output from the test of the fit.


\section{Data set requirements for application of anota}
anota can analyse data from both sequencing based methods and the more standard polysome microarray method. anota cannot use data from competitive two channel experiments when the translationally active mRNA is directly compared to cytosolic mRNA as these do not allow independent estimates of the cytosolic and the translationally active mRNA levels. A two-channel reference design should be applicable although we have not tested this data type. anota requires 3 replicate experiments per group. The performance will vary depending on the normalization and the transformation of the data. We therefore recommend that the user tries several different transformations and normalization while monitoring the quality control plots (the influential data points, the interactions and the normality of the residuals) and the RVM F-distribution fit plot if RVM is used. We recommend using RVM as it improves the power to detect differential translation activity within anota \cite{Larsson3}.

 
\section{Example}
The example illustrates a typical analysis procedure using a part of the data set reported in \cite{Larsson2}

<<echo=TRUE, eval=TRUE>>=
##Loading the library and data set, perform quality control and identify significant translational regulation. No RVM is applied in the example.
 library("anota")
 data(anotaDataSet)
 anotaQcOut <- anotaPerformQc(dataT=anotaDataT[1:200,], dataP=anotaDataP[1:200,], phenoVec=anotaPhenoVec, nDfbSimData=500, useProgBar=FALSE)
 anotaResidOut <- anotaResidOutlierTest(anotaQcObj=anotaQcOut, useProgBar=FALSE)
 anotaSigOut <- anotaGetSigGenes(dataT=anotaDataT[1:200,], dataP=anotaDataP[1:200,], phenoVec=anotaPhenoVec, anotaQcObj=anotaQcOut, useRVM=FALSE, useProgBar=FALSE)
anotaSelected <- anotaPlotSigGenes(anotaSigObj=anotaSigOut, selContr=1, maxP=0.1, minSlope=(-0.5), maxSlope=1.5, selDeltaPT=0.5)
@ 

\begin{thebibliography}{10}
 
\bibitem{Larsson1}
  Larsson, O. and Nadon, R.
  Gene expression: Time to change point of view?
  {\em Biotechnology and Genetic Engineering Reviews}, 2008, 25
  p77-92. 
  
\bibitem{seqRef}
  Ingolia, NT et al.
  Genome-wide analysis in vivo of translation with nucleotide resolution using
  ribosome profiling.
  {\em Science}, 2009, 10;324(5924):218-23.
  
\bibitem{Larsson3}
  Larsson, O. et al.
  Identification of differential translation in genome wide studies.
  {\em PNAS}, 2010, 107;50:21487-21492. 
  
\bibitem{Larsson2}
  Larsson, O. et al.
  Fibrotic myofibroblasts manifest genome-wide derangements of translational
  control.
  {\em PLoS One}, 2008, 3 (9) e3220.
  
\bibitem{MAS}
  Venable, W.N. and Ripley, B.D.
  Modern applied statistics with S-PLUS.
  {\em Springer}, 1999.

\bibitem{rvm}
  Writht, G.W. and Simon, R.M.
  A random variance model for detection of differential gene expression in
  small microarray expeirments.
  {\em Bioinformatics}, 2003, 12;19(19):2448-55.
\end{thebibliography}

\end{document}

\name{anotaResidOutlierTest}
\alias{anotaResidOutlierTest}

\title{
  Test for normality of residuals
}

\description{
  One assumption when performing APV is that the residuals from the
  regressions are normally distributed. anota assesses this by comparing
  the Q-Q plots of the residuals to envelopes derived by sampling from the normal distribution. 
}

\usage{
anotaResidOutlierTest(anotaQcObj=NULL, confInt=0.01, iter=5,
generateSingleGraph=FALSE, nGraphs=200, generateSummaryGraph=TRUE,
residFitPlot=TRUE, useProgBar=TRUE)
}

\arguments{
  \item{anotaQcObj}{The object returned by anotaPerformQc.}
  \item{confInt}{Controls how many samples from the normal
    distribution will be used to generate the envelope to which the
    residuals are compared. 
Default is 0.01 which will generate 99
    samples from the normal distribution to compare to the actual
    residuals.}
  \item{iter}{How many times should the analysis be performed? Default is
    5 meaning that 5 sets of samples (each with the size controlled
    by confInt) will be generated. Notice that the summary plotting is
    only performed for the last set but the percentage of outliers for
    each iteration can be found in the output object.}
  \item{generateSingleGraph}{The analysis is performed per identifier and
    plots can be generated for each identifier. However, due to the high
    number of identifiers, a large number of plots will typically be
    generated. Default is FALSE.}
  \item{nGraphs}{If generateSingleGraph is set to TRUE, nGraphs
    controls for how many identifiers such single gene graphs will be generated.}
  \item{generateSummaryGraph}{The function can generate a summary graph
    that shows the envelopes generated by sampling from the normal
    distribution compared to the obtained values for all genes. Default
    is TRUE, thus the graph is generated but only from the last iteration.}
  \item{residFitPlot}{Generates an output of the fitted values and
    residuals. Default is TRUE, generate the plot.}
  \item{useProgBar}{Should the progress bar be shown. Default is TRUE,
    show progress bar.}

}

\details{
  The anotaResidOutlierTest function assesses whether the residuals from
  the per identifier linear regressions of translationally active mRNA level~cytosolic mRNA level+phenoType are
  normally distributed. anota generates normal Q-Q plots of the
  residuals.  If the residuals are normally distributed, the data
  quantiles will form a straight diagonal line from bottom left to top
  right.  Because there are typically relatively few data points, anota
  calculates "envelopes" based on a set of samplings from the normal
  distribution using the same number of data points as for the true data
  (Venables and Ripley 1999).To enable a comparison both the actual and the
  sampled data are centered (mean=0) and scaled (sd=1). The data
  (both true and sampled) are then sorted and the true sample is compared
  to the envelopes of the sampled data at each sort position. The result
  is presented as a Q-Q plot of the true data where the envelopes of
  the sampled data are indicated. If there are 99 samplings we expect
  that 1/100 values to be outside the envelopes obtained from the
  samplings. Thus it is possible to assess if approximately the expected
  number of outlier residuals are obtained. The result is presented as
  both a graphical output and an output object.
}

\value{
  anotaResdiOutlierTest generates a graphical output
  ("ANOTA_residual_distribution_summary.pdf") showing the Q-Q plots
  from all genes as well as the envelopes from the
  sampled data. The obtained
  percentage of outliers is shown at each rank position and all combined. Optionally, when the generateSingleGraph is set to TRUE,
  the function also generates individual plots (stored as
  "ANOTA_residual_distributions_single.pdf") for n genes (set by
  nGraphs). When residFitPlot is set to TRUE an output comparing the
  fitted values to the residuals is generated (stored as
  "ANOTA_residuals_vs_fitted.jpeg"). An output list object with the following
  slots is also generated:
  \item{confInt}{The selected confInt (see function arguments).}
  \item{inputResiduals}{The residuals used.}
  \item{rnormIter}{The number of sampled data sets.}
  \item{outlierMatrixLog}{A logical matrix describing which residuals
    were outliers in the last iteration of the analysis.}
  \item{meanOutlierPerIteration}{The fraction outliers per iteration.}
  \item{obtainedComparedToExpected}{The ratio of the expected number of
    outlier residuals compared to the expected number of outliers given the
    selected confInt.}
  \item{nExpected}{Number of expected outlier residuals.}
  \item{nObtained}{Number of obtained outliers residuals.}
}

\author{Ola Larsson \email{ola.larsson@ki.se}, Nahum Sonenberg
\email{nahum.sonenberg@mcgill.ca}, Robert Nadon \email{robert.nadon@mcgill.ca}}

\examples{
 ## See example for \code{\link{anotaPlotSigGenes}}
}

\seealso{\code{\link{anotaPerformQc}}, \code{\link{anotaGetSigGenes}}, \code{\link{anotaPlotSigGenes}}} 
\keyword{methods}

\source{Modern Applied Statistics with S-PLUS. Venables, B.N. and
  Ripley, B.D., Springer. 1999}

\name{anotaPlotSigGenes}
\alias{anotaPlotSigGenes}

\title{
  Filter and plot genes to visualize/summarize genes that are
  differentially translated.
}

\description{
  This function filters the output from the anotaGetSigGenes function based on
  many user defined thresholds and flags to generate a summary table and
  optional per gene plots.
}

\usage{
anotaPlotSigGenes(anotaSigObj, selIds=NULL, selContr=NULL, minSlope=NULL, maxSlope=NULL, slopeP=NULL, minEff=NULL, maxP=NULL, maxPAdj=NULL, maxRvmP=NULL, maxRvmPAdj=NULL, selDeltaPT=NULL, selDeltaP=NULL, sortBy=NULL, performPlot=TRUE, fileName="ANOTA_selected_significant_genes_plot.pdf", geneNames=NULL)
}

\arguments{
  \item{anotaSigObj}{The output from the anotaGetSigGenes function.}
  \item{selIds}{The function can consider only a subset of the
    identifiers from the input data set (which can be further filtered)
    or used for custom plotting of identifiers of interest (leaving all
    filters as NULL). For custom selection of identifiers, supply a vector of identifiers
    (row names from the original data set) to be
    included. Default is NULL i.e. filtering is performed on all
    identifiers. Minimum length of selIds is currently 2. However, if
    only one identifier is of interest this identifier can be at
    position one and two of the supplied vector which will lead to that
    the data for the identifier of interested will be plotted twice.}
  \item{selContr}{Which contrast should be evaulated during the
    filtering, sorting and plotting? Descriptions of
    the contrasts can be found in the output from the anotaGetSigGenes
    object in the usedContrasts slot. Indicate the contrast by the column
    number.}
  \item{minSlope}{The output can be filtered so that genes whose
    identified slopes are too small can be excluded. Default is NULL
    i.e. no filtering based on lower boundary of the slope. To exclude
    genes with e.g. a slope <(-1) assign -1 to minSlope.}
  \item{maxSlope}{The output can be filtered so that genes whose
    identified slopes are too large can be excluded. Default is NULL
    i.e. no filtering based on upper boundary of the slope. To exclude
    genes with e.g. a slope >2 assign 2 to maxSlope.}
  \item{slopeP}{A p-value for the slope being <0 or >1 is calculated if the estimate
    for the slope is <0 or >1. This p-value can be used to
    filter the output based on unrealistic slopes. When set low fewer
    genes will be disqualified. Default is NULL i.e. no filtering based
    on slope p-value. We recommend setting slopeP between 0.01 and 0.1
    depending on data set characteristics.}
  \item{minEff}{The output can be filtered based on minimum effect for
    inclusion. The value is applied both to negative and positive effects:
    e.g. a value of 1 will evaluate if the effects are >1 OR
    <(-1). Default is NULL i.e. no filtering based on effect.}
  \item{maxP}{The output can be filtered based on raw p-values from the
    anota analysis without RVM  (i.e. smaller compared to assigned
    value). Default is NULL i.e. no filtering.}
  \item{maxPAdj}{The output can be filtered based on adjusted p-values from the
    anota analysis without RVM (i.e. smaller compared to assigned
    value). The adjustment method that was used when running
    anotaGetSigGenes will be evaluated. Default is NULL i.e. no filtering.}
  \item{maxRvmP}{The output can be filtered based on raw p-values from the
    anota analysis with RVM (i.e. smaller compared to assigned
    value). Default is NULL i.e. no filtering.}
  \item{maxRvmPAdj}{The output can be filtered based on adjusted p-values from the
    anota analysis with RVM (i.e. smaller compared to assigned value). The
    adjustment method that was used when running
    anotaGetSigGenes will be evaluated. Default is NULL i.e. no filtering.}
  \item{selDeltaPT}{The output can be filtered based on the mean log2(translational
    activity data / cytosolic mRNA data) between groups difference. The
    groups are defined by the selected contrast. Default is
    NULL i.e. no filtering.}
  \item{selDeltaP}{The output can be filtered based on the translational
    activity data only so that the minimum absolute between groups delta
    translation is used for gene inclusion. The groups are defined by
    the selected contrast. Default is NULL i.e. no filtering.}
  \item{sortBy}{The output can be sorted by effect ("Eff"), raw
    p-value("p") or raw RVM p-value ("apvRvmP"). Default is NULL i.e. no sorting.}
  \item{performPlot}{The function can generate a graphical output per
    gene. Default is TRUE i.e. generate plots.}
  \item{fileName}{The plots are printed to a file whose file name is
    given here. Default is "ANOTA_selected_significant_genes_plot.pdf".}
  \item{geneNames}{When anotaPlotSigGenes plots the individual gene plots
    they will be named by the original row names supplied to the
    anotaGetSigGenes function. geneNames allows the user to add additional
    names when plotting to e.g. include gene symbols. Input is a matrix
    with one column where the original row names match the row names of the input matrix and
    the desired new names are given in column 1.  Default is NULL
    i.e. no additional names.}
}

\details{
  This function allows the user to filter the output generated from the
  anotaGetSigGenes function to derive a reduced selection of genes that
  are considered for further evaluation. This is done by setting one or
  several of the filtering parameters described above. The function also
  generates a graphical output which helps when evaluating a single gene's
  regulation. In the graphical output, the results for each gene is
  displayed on separate rows. The first graph shows all samples and
  per sample class regression lines using the common slope with different colors
  for each sample class. The magnitude of the common slope is indicated. The second graph
  shows key statistics for the gene without the RVM model for all
  contrasts analyzed when running anotaGetSigGenes but any ordering and
  selection of genes is performed on the contrast given by the selContr
  argument as described above. The third graph is similar to the second but
  with RVM statistics instead (if RVM was used in the anotaGetSigGenes analysis).
}

\value{
  anotaPlotSigGenes generates a graphical output as described above and
  a list object containing summary data for those genes that passed the
  selected set of filters. The output list object contains the following
  slots:
  \item{selectedData}{A matrix containing non-RVM data for the filtered
    identifiers. Columns are "apvSlope" (the common slope used in APV);
    "apvSlopeP" (if the slope is <0 or >1 a p-value for the slope being <0
    or >1 is calculated; if the slope is >=0 & <=1 this value is set to
    1); "unadjustedResidError" (the residual error before calculating the
    effective residual error); "apvEff" (the group effect); "apvMSerror"
    (the effective mean square error); "apvF" (the F-value); "residDf"
    (the residual degrees of freedom); "apvP" (the p-value); "apvPAdj"
    (the adjusted p-value).} 
  \item{selectedRvmData}{A matrix containing RVM data for the filtered
    identifiers. Columns are "apvSlope" (the common slope used in APV);
    "apvSlopeP" (if the slope is <0 or >1 a p-value for the slope being <0
    or >1 is calculated; if the slope is >=0 & <=1 this value is set to
    1); "apvEff" (the group effect); "apvRvmMSerror" (the effective mean
    square error after RVM); "apvRvmF" (the RVM F-value); "residRvmDf"
    (the residual degrees of freedom after RVM); "apvRvmP" (the RVM
    p-value); "apvRvmPAdj" (the adjusted RVM p-value).}
  \item{groupIntercepts}{A matrix with the group intercepts, i.e. the
    translational activity for each group independent of cytosolic mRNA level. Can be used for
    e.g. clustering of translational activity. Data for all groups
    defined when using the anotaGetSigGenes function are supplied
    although the filtering is based on the contrast defined under the
    selContr argument.}
  \item{deltaData}{Mean delta translational activity data ("deltaP"), mean
    delta cytosolic mRNA data ("deltaT") and  mean delta log ratio data
  ("deltaPT") comparing the sample classes specified by the selected contrast.}
  \item{usedThresholds}{A list object with the user set values for the filtering.}
}

\author{Ola Larsson \email{ola.larsson@ki.se}, Nahum Sonenberg
  \email{nahum.sonenberg@mcgill.ca}, Robert Nadon \email{robert.nadon@mcgill.ca}}

\examples{
 ## Load the library and dataset (two phenotypes)
  library(anota)
  data(anotaDataSet)
 ## Quality control of the data set.
  anotaQcOut <- anotaPerformQc(dataT= anotaDataT[1:200,], dataP=anotaDataP[1:200,],
phenoVec=anotaPhenoVec, nDfbSimData=500)
 ##Test normality of residuals
  anotaResidOut <- anotaResidOutlierTest(anotaQcObj=anotaQcOut)
 ##Identify differentially translated genes.
  anotaSigGeneOut <- anotaGetSigGenes(dataT= anotaDataT[1:200,],
dataP=anotaDataP[1:200,], phenoVec=anotaPhenoVec, anotaQcObj=anotaQcOut)
 ##Plot some of the differentially expressed mRNAs
  anotSigGeneOutFiltered <-
anotaPlotSigGenes(anotaSigObj=anotaSigGeneOut, selContr=1,
maxP=0.05,slopeP=0.05, maxSlope=1.5, minSlope=(-0.5), selDeltaPT=0.5)
}

\seealso{\code{\link{anotaPerformQc}}, \code{\link{anotaResidOutlierTest}}\code{\link{anotaGetSigGenes}}} 
\keyword{methods}

\name{anotaGetSigGenes}
\alias{anotaGetSigGenes}

\title{
  Identify genes that are under translational control independent of
  cytosolic mRNA levels
}

\description{
  This function uses analysis of partial variance (APV) to identify genes that are under translational
  regulation independent of cytosolic mRNA levels.
}

\usage{
anotaGetSigGenes(dataT=NULL, dataP=NULL, phenoVec=NULL, anotaQcObj=NULL,
correctionMethod="BH", contrasts=NULL, useRVM=TRUE, useProgBar=TRUE)
}

\arguments{
  \item{dataT}{A matrix with cytosolic mRNA data. Non numerical rownames
  are needed.}
  \item{dataP}{A matrix with translational activity data. Non numerical rownames
  are needed.}
  \item{phenoVec}{A vector describing the sample classes (each class
    should have a unique identifier). Note that dataT, dataP and phenoVec
    have to have the same sample order so that column 1 in dataP is
    the translational data for a sample, column 1 in dataT is the
    cytosolic mRNA data and position 1 in phenoVec describes the sample
    class.}
  \item{anotaQcObj}{The object returned by anotaPerformQc.}
  \item{correctionMethod}{anota corrects p-values for multiple testing using the
    multtest package. Correction method can be "Bonferroni", "Holm",
    "Hochberg", "SidakSS", "SidakSD", "BH", "BY", "ABH" or
    "TSBH" as implemented in the multtest package or "qvalue" as
  implemented in the qvalue package. Default is "BH".}
  \item{contrasts}{When there is more than 2 sample categories it is
    possible to use custom contrasts. The order of the sample
    classes needs to be correct and can be seen in the object generated
    from anotaPerformQc in the phenoClasses slot (see details section).}
  \item{useRVM}{Should the Random Variance Model be applied. Default is
    TRUE.}
  \item{useProgBar}{Should the progress bar be shown. Default is TRUE,
    show progress bar.}
  
}

\details{
  The function performs APV on two or
  more sample categories. When more than two sample classes are
  compared it is possible to set custom contrasts to compare the sample
  classes of interest. Otherwise "treatment" contrasts are used which follow
  the alphabetical order of the sample classes. The order of the sample classes which
  the contrast matrix should follow can be found in the output of the
  anotaPerformQc function in the phenoClasses slot. Contrasts are supplied
  as a matrix where the sample classes are rows (same order as phenoClasses) and
  the columns are the different contrasts used. Contrasts are
  coded by using e.g. -1 for group a, 0 for group b and 1 for
  group c to compare group a and c; -2 for group a, 1 for group b and 1 for
  group c to compare group a to b & c. Each column of the contrast matrix
  should sum to 0 and to analyze orthagonal contrasts the products of
  all pairwise rows should sum to 0. The results will follow the order of the contrasts,
  i.e. the anocovaStats slot in the output object is a list with positions
  1...n where 1 is the first contrast and n is the last.

  A rare error can occur when data within dataT or dataP from any gene
  and any sample class has no variance. This is reported as "ANOVA
  F-TEST on essentially perfect fit...". In this case those genes that
  show no variance for a sample class within either dataT or dataP need
  to be removed before analysis. Trying a different normalization method
  may fix the problem.

}

\value{
  anotaGetSigGenes creates a plot showing the fit of the inverse gamma
  distribution used in RVM (similar output as from anotaPerformQc). anotaGetSigGenes also returns
  a list object with the following slots:
  \item{apvStats}{A list object (each slot named from 1 to the number
    of contrasts) where  each slot contains a matrix with statistics from
    the applied APV for that contrast. Columns are "apvSlope" (the
    common slope used in APV); "apvSlopeP" (if the slope is <0 or >1 a p-value
    for the slope being <0 or >1 is calculated; if the slope is >=0 & <=1
    this value is set to 1); "unadjustedResidError" (the residual error
    before calculating the effective residual error); "apvEff" (the group
    effect); "apvMSerror" (the effective mean square error); "apvF" (the F-value);
    "residDf" (the residual degrees of freedom); "apvP" (the p-value);
    "apvPAdj" (the adjusted p-value).}
  
  \item{apvStatsRvm}{A summary list object (each slot named from 1 to
    the number of contrasts) where each slot contains a matrix with RVM
    statistics from the applied APV. Columns are "apvSlope" (the
    common slope used in APV); "apvSlopeP" (if the slope is <0 or >1 a p-value
    for the slope being <0 or >1 is calculated; if the slope is >=0 & <=1
    this value is set to 1); "apvEff" (the group
    effect); "apvRvmMSerror" (the effective mean square error after RVM); "apvRvmF"
    (the RVM F-value); "residRvmDf" (the residual degrees of freedom
    after RVM); "apvRvmP" (the RVM p-value); "apvRvmPAdj" (the adjusted
    RVM p-value).}
  \item{correctionMethod}{The multiple testing correction  method used to adjust
    the p-values.}
  \item{usedContrasts}{A matrix with the contrasts used. Order is same as in the
    statistical outputs (column wise) so that the first contrast is
    found in the first slot of the apvStats and the apvStatsRvm lists.}
  \item{abList}{A list object containing the a and b parameters from the
    inverse gamma fits. Same order as the contrasts.}
}

\author{Ola Larsson \email{ola.larsson@ki.se}, Nahum Sonenberg
  \email{nahum.sonenberg@mcgill.ca}, Robert Nadon \email{robert.nadon@mcgill.ca}}

\examples{
 ## See example for \code{\link{anotaPlotSigGenes}}
}

\seealso{\code{\link{anotaPerformQc}},
  \code{\link{anotaResidOutlierTest}}, \code{\link{anotaPlotSigGenes}}} 
\keyword{methods}

\name{anotaDataSet}
\docType{data}
\alias{anotaDataSet}
\alias{anotaDataP}
\alias{anotaDataT}
\alias{anotaPhenoVec}
\title{Sample data set for anota}
\description{
  6 samples with data from 2 sample categories, both cytosolic
  (anotaDataT) and translational (anotaDataP) together with a sample
  class vector (anotaPhenoVec).
}

\usage{data(anotaDataSet)}


\format{Each data matrix (anotaDataT and anotaDataP) has 1000 rows
  (1000 first identifiers from complete data set) and 6 columns (noAA or
  rich). The anotaPhenoVec vector contains the sample class of each
  sample and anotaDataT, anotaDataP and phenoVec follow the same order.}

\source{Ingolia, NT et al. Genome-wide analysis in vivo of translation
  with nucleotide resolution using ribosome profiling. Science, 2009, 10;324(5924):218-23}

\examples{
##load data set
data(anotaDataSet)
##check dimensions
dim(anotaDataP)
head(anotaDataP)

dim(anotaDataT)
head(anotaDataT)

anotaPhenoVec
}
\keyword{datasets}

\name{anotaPerformQc}
\alias{anotaPerformQc}

\title{
  Perform quality control to ensure that the supplied data set is
  suitable for Analysis of Partial Variance (APV) within anota.
}

\description{
  Generates a distribution of interaction p-values which are compared to
  the expected NULL distribution. Also assesses the frequency of highly
  influential data points using dfbetas for the regression slope and
  compares the dfbetas to randomly generated simulation data. Calculates
  omnibus class effects.
}

\usage{
anotaPerformQc(dataT=NULL, dataP=NULL, phenoVec=NULL,
generatePlot=FALSE, file="ANOTA_Total_vs_Polysomal_regressions.pdf",
nReg=200, correctionMethod="BH", useDfb=TRUE, useDfbSim=TRUE,
nDfbSimData=2000, useRVM=TRUE, onlyGroup=FALSE, useProgBar=TRUE)
}

\arguments{
  \item{dataT}{A matrix with cytosolic mRNA data. Non numerical rownames
  are needed.}
  \item{dataP}{A matrix with translational activity data. Non numerical rownames
  are needed.}
  \item{phenoVec}{A vector describing the sample classes (each class
    should have a unique identifier). Note that dataT, dataP and phenoVec
    must have the same sample order so that column 1 in dataP is
    the translational activity data for a sample, column 1 in dataT is the
    cytosolic mRNA data and position 1 in phenoVec describes the sample
    class.}
  \item{generatePlot}{anota can plot the regression for each gene. However,
    as there are many genes, this output is normally not
    informative. Default is FALSE, no individual plotting.}
  \item{file}{If generatePlot is set to TRUE use file to set
    desired file name (prints to current directory as a pdf).
    Default is "ANOTA_Total_vs_Polysomal_regressions.pdf"}
  \item{nReg}{If generatePlot is set to TRUE, nReg can be used to
    limit the number of output plots. Default is 200.}
  \item{correctionMethod}{anota adjusts the omnibus interaction and
    sample class p-values for multiple testing. Correction method can be "Bonferroni", "Holm",
    "Hochberg", "SidakSS", "SidakSD", "BH", "BY", "ABH" or
    "TSBH" as implemented in the multtest package or "qvalue" as
    implemented in the qvalue package. Default is "BH".}
  \item{useDfb}{Should anota assess the occurrence of highly influential
    data points (defult is TRUE)?}
  \item{useDfbSim}{The random occurrence of dfbetas can be
    simulated. Default is TRUE. FALSE represses simulation which reduces
    computation time but makes interpretation of the dfbetas difficult.}
  \item{nDfbSimData}{If useDfbSim is TRUE the user can select the
    number of samplings that will be performed per step (10 steps with
    different correlations between the translationally activty and the
    cytosolic mRNA level). Default is 2000.}
  \item{useRVM}{The Random Variance Model (RVM) can be
    used for the omnibus sample class comparison. In this case the effect of RVM
    on the distribution of the interaction significances needs to be
    tested as well. Default (TRUE) leads to calculation of RVM p-values
    for both omnibus interactions and omnibus sample class effects.}
  \item{onlyGroup}{It is possible to suppress the omnibus interaction
    analysis and only perform the omnibus sample class effect analysis. Default
    is FALSE (analyse both interactions and sample class effects.)}
  \item{useProgBar}{Should the progress bar be shown. Default is TRUE,
    show progress bar.}
}

\details{
  The anotaPerformQc performs the basic quality control of the data
  set. Two levels of quality control are assessed, both of which need to show good
  performance for valid application of anota. First, anota assumes that
  there are no interactions (for slopes). The output for this analysis is  both a density plot and a histogram plot of both the raw p-values and
  the p-values adjusted by the selected multiple correction method (if
  RVM was used, the second page shows the same presentation using RMV
  p-values). anota requires a uniform distribution of the raw
  interaction p-values for valid analysis of differential translation. anota also assesses if
  there are more data points with high influence on the regression analyses than
  would be expected by chance. anota identifies influential data points as
  data points that influence the slope of the regression using standardized dfbeta
  (dfbetas). In the literature there are multiple suggestions of what
  should be regarded as an outlier dfbetas (dfbetas>1, dfbetas>2,
  dfbetas>3, dfbetas>(2/sqrt(N)), dfbetas>(3/sqrt(N)),
  dfbetas>(3.5*IQR)). Independent of which threshold is preferred, what is of
  interest is the comparison to the underlying distribution. As this
  distribution is unknown, we simulate random data sets assuming that the
  cytosolic mRNA level and the translationally active mRNA levels are normally
  distributed and that there is a correlation between the cytosolic and the
  translationally active mRNA level. Following such simulation the frequencies of
  outlier dfbetas (using all thresholds) is compared to the frequencies found
  in the simulated data set. The function also performs an omnibus sample class
  effect test if there are more than 2 sample classes. It is possible to use RVM for the omnibus
  sample class statistics. If RVM is used, it
  is necessary to verify that the interaction RVM p-values also follow the
  expected NULL distribution.
  A rare error can occur when data within dataT or dataP from any gene
  and any sample class has no variance. This is reported as "ANOVA
  F-TEST on essentially perfect fit...". In this case those genes that
  show no variance for a sample class within either dataT or dataP need
  to be removed before analysis. Trying a different normalization method
  may fix the problem.
}

\value{
  anotaPerformQc generates several graphical outputs. One output
  ("ANOTA_interaction_p_distribution.pdf") shows the distribution of
  p-values and adjusted p-values for the omnibus interaction (both using
  densities and histograms). The second page of the pdf displays the
  same plots but for the RVM statistics if RVM is used. One output
  ("ANOTA_simulated_vs_obtained_dfbs.pdf") shows  bar graphs of the
  frequencies of outlier dfbetas using different dfbetas thresholds. If
  the simulation was enabled (recommended) these are compared to the
  frequencies from the random data set. One optional graphical output
  shows the gene by gene regressions with the sample classes
  indicated. In the case where RVM is used, a Q-Q plot and a comparison of the
  CDF of the variances to the theoretical CDF of the F-distribution is
  generated (output as "ANOTA_rvm_fit_for_....jpg") for both the omnibus
  sample class and the omnibus interaction test. The function also
  outputs a list object containing the following data:
  
  \item{omniIntStats}{A matrix with a summary of the statistics from the
    omnibus interaction analysis containing the following columns:
    "intMS" (the mean square for the interaction); "intDf" (the degrees
    of freedom for the interaction); "residMS" (the residual error mean
    square); "residDf" (the degrees of freedom for the residual error);
    "residMSRvm" (the mean square for the residual error after applying
    RVM); "residDfRvm"(the degrees of freedom for the residual error after
    applying RVM); "intRvmFval" (the F-value for the RVM statistics);
    "intP" (the p-value for the interaction); "intRvmP" (the p-value for
    the interaction using RVM statistics); "intPAdj" (the adjusted [for
    multiple testing using the selected multiple testing correction method]
    p-value of the interaction); "intRvmPAdj"(the adjusted [for
    multiple testing using the selected multiple testing correction method]
    p-value of the interaction using RVM statistics).}
  
  \item{omniGroupStats}{A matrix with a summary of the statistics from the
    omnibus sample class analysis containing the following
    columns:"groupSlope" (the common slope used in APV); "groupSlopeP" (if the slope is <0 or >1 a p-value
    for the slope being <0 or >1 is calculated; if the slope is >=0 & <=1
    this value is set to 1); "groupMS" (the mean square for sample classes);
    "groupDf" (the degrees  of freedom for the sample classes); "groupResidMS"
    (the residual error mean square); "groupResidDf" (the degrees of freedom
    for the residual error); "residMSRvm" (the mean square for the
    residual error after applying RVM); "groupResidDfRvm"(the degrees of
    freedom for the residual error after applying RVM); "groupRvmFval" (the F-value for the RVM statistics);
    "groupP" (the p-value for the sample class effect); "groupRvmP" (the p-value for
    the sample class effect using RVM statistics); "groupPAdj" (the adjusted [for
    multiple testing using the selected multiple testing correction method]
    p-value of the sample class effect); "groupRvmPAdj"(the adjusted [for
    multiple testing using the selected multiple testing correction method]
    p-value of the sample class effect using RVM statistics).}
  
  
  \item{correctionMethod}{The multiple testing correction method used to adjust the nominal p-values.}

  \item{dsfSummary}{A vector with the obtained frequencies of outlier
    dfbetas without the interaction term in the model.}
  
  \item{dfbetas}{A matrix with the dfbetas from the model without the
  interaction term in the model.}
  
  \item{residuals}{The residuals from the regressions without the
  interaction term in the model.}
  
  \item{fittedValues}{A matrix with the fitted values from the
    regressions without the interaction term in the model.}
  
  \item{phenoClasses}{The sample classes used in the analysis. The
    sample class order
    can be used to create the contrast matrix when identifying
    differential translation using anotaGetSigGenes.}
  
  \item{sampleNames}{A vector with the sample names (taken from the
    translationally active samples).}
  \item{abParametersInt}{The ab parameters for the inverse gamma fit for the interactions within RVM.}
  \item{abParametersGroup}{The ab parameters for the inverse gamma fit
    for sample classes within RVM.}
}

\author{Ola Larsson \email{ola.larsson@ki.se}, Nahum Sonenberg
  \email{nahum.sonenberg@mcgill.ca}, Robert Nadon \email{robert.nadon@mcgill.ca}}

\examples{
 ## See example for \code{\link{anotaPlotSigGenes}}

}

\seealso{\code{\link{anotaResidOutlierTest}}, \code{\link{anotaGetSigGenes}},\code{\link{anotaPlotSigGenes}}} 
\keyword{methods}
